program SimulatorStoparice; { RTK 1988.1.3 }
uses Crt, Dos;

  function Tipka: boolean; forward; 
  function Impulz: boolean; forward; 
  procedure Zaslon(h, m, s, cs: integer); forward; 

procedure Stoparica;
var 
  Tece: boolean;                { ura tee } 
  Brisi: integer;               { 0 ali as v stotinkah do brisanja asa } 
  t, tPrej: boolean;            { trenutno in prejnje stanje tipke } 
  h, m, s, cs: integer;         { ure, minute, sekunde, stotinke } 
begin {Stoparica} 
  Tece := false; Brisi := 0; tPrej := false; 
  h := 0; m := 0; s := 0; cs := 0; Zaslon(h, m, s, cs); 
  repeat 
    t := Tipka; 
    if t and not tPrej then begin Tece := not Tece; Brisi := 50 end
    else if tPrej and not t then Brisi := 0; 
    tPrej := t; 
    if Impulz then begin
      if Brisi > 0 then begin
        Brisi := Brisi - 1;      { merimo as do brisanja asa } 
        if Brisi = 0 then begin  { as je za brisanje zaslona } 
          h := 0; m := 0; s := 0; cs := 0; Zaslon(h, m, s, cs); 
          Tece := false;         { po brisanju naj ura stoji } 
        end; {if}
      end; {if}
      if Tece then begin         { e ura tee, popravimo zaslon } 
        cs := cs + 1; 
        if cs >= 100 then begin
          s := s + 1; cs := cs - 100; 
          if s >= 60 then begin m := m + 1; s := s - 60 end;
          if m >= 60 then begin h := h + 1; m := m - 60 end;
          if h >= 24 then h := h - 24; 
        end; {if}
        Zaslon(h, m, s, cs); 
      end; {if Tece} 
    end; {if Impulz} 
  until false; 
end; {Stoparica} 

{-----------------------------------------------------------------------------}
{ Preostanek programa simulira okolje, v katerega je postavljen               }
{ podprogram Stoparica.                                                       }
{-----------------------------------------------------------------------------}

type CasT = record h, m, s, cs: integer end;
var TipkaPritisnjena: boolean;
    NaZaslonu, ZadnjiImpulz, CasPritiska: CasT;

procedure TrenutniCas(var Cas: CasT);
var h, m, s, cs: word;
begin
  GetTime(h, m, s, cs);
  Cas.h := h; Cas.m := m; Cas.s := s; Cas.cs := cs;
end; {TrenutniCas}
    
function Tipka: boolean;
begin
  Tipka := TipkaPritisnjena;
end; {Tipka}

procedure PrikaziStanje;
var C: CasT; i: integer;
begin
  TrenutniCas(C);
  if TipkaPritisnjena then begin
    with CasPritiska do
      i := (((C.h - h) * 60 + C.m - m) * 60 + C.s - s) * 100 + C.cs - cs;
    if i < 0 then i := i + 24 * 60 * 60 * 100;
    Write('TIPKA ', (0.01 * i):6:2);
  end
  else Write('            ');
  with NaZaslonu do 
    Write('  Zaslon: ', h div 10, h mod 10, ':', m div 10, m mod 10,
      ':', s div 10, s mod 10, '.', cs div 10, cs mod 10, #13);
end; {PrikaziStanje}

function Impulz: boolean; 
var C: CasT; ch: char;
begin
  { Ob tej priliki e poglejmo, e je uporabnik 
    pritisnil na kakno tipko. }
  while KeyPressed do begin
    ch := UpCase(ReadKey); if ch = #0 then ReadKey;
    if (ch = 'X') or (ch = 'Q') or (ch = #27) then Halt
    else if (ch = 'P') then begin
      Write('(Pavza.)', #13);
      ch := UpCase(ReadKey); if ch = #0 then ReadKey;
      PrikaziStanje;
    end else if (ch = ' ') then begin
      TipkaPritisnjena := not TipkaPritisnjena;
      if TipkaPritisnjena then TrenutniCas(CasPritiska);
      PrikaziStanje;
    end; {if}
  end; {while}
  
  { Poglejmo zdaj, e smo od zadnjega klica podprograma
    Impulz e prili v novo stotinko sekunde. }
  TrenutniCas(C);
  with ZadnjiImpulz do 
    if (h = C.h) and (m = C.m) and (s = C.s) and (cs = C.cs) 
    then Impulz := false
    else begin Impulz := true; ZadnjiImpulz := C; PrikaziStanje end;
end; {Impulz}

procedure Zaslon(h, m, s, cs: integer); 
begin
  NaZaslonu.h := h;
  NaZaslonu.m := m;
  NaZaslonu.s := s;
  NaZaslonu.cs := cs;
  PrikaziStanje;
end; {Zaslon}

begin {SimulatorStoparice}
  WriteLn('Simulator toparice');
  WriteLn('Preslednica = pritisne/spusti tipko na toparici');
  WriteLn('P = pavza, Q ali X = izhod iz programa.');
  WriteLn;
  TipkaPritisnjena := false;
  TrenutniCas(ZadnjiImpulz); 
  Stoparica;
end. {SimulatorStoparice}
