program Bloki; { RTK 1988.2.1 }
const MaxPot = 64;          { najveja dolina poti } 
type 
  SmerT = (Naprej, Skok);   { tip koraka do naslednjega bloka } 
  PotT = packed array[0..MaxPot] of SmerT;        { opis poti } 

{ Doloi najkrajo pot do bloka datoteke na disku.  } 
procedure PotDoBloka(StZap: integer; var Pot: PotT); 
var 
  Korak: integer;   { tevec korakov na poti } 
  Blok: integer;    { tevec blokov, skozi katere gre pot } 
  Zadnji: integer;  { zadnji korak } 
  t: SmerT; 
begin
  { Najprej doloimo pot v smeri od bloka nazaj proti zaetku datoteke. } 
  Korak := 0; Blok := StZap; 
  while Blok > 1 do begin 
    if Odd(Blok) then 
      begin Korak := Korak + 1; Pot[Korak] := Naprej; Blok := Blok - 1 end;
    Korak := Korak + 1; Pot[Korak] := Skok; Blok := Blok div 2; 
  end; {while}
  { sedaj pot obrnemo } 
  Zadnji := Korak; 
  for Korak := 1 to Zadnji div 2 do begin 
    t := Pot[Korak]; 
    Pot[Korak] := Pot[Zadnji - Korak];
    Pot[Zadnji - Korak] := t; 
  end; {for}
end; {PotDoBloka}

procedure Test(StZap: integer);
var Pot: PotT; Blok, i: integer;
begin
  PotDoBloka(StZap, Pot);
  i := 0; Blok := 1;
  while true do begin
    Write(Blok);
    if Blok = StZap then break;
    if Pot[i] = Skok then begin
      Write(' => '); Blok := 2 * Blok;
    end else begin
      Write(' -> '); Blok := Blok + 1;
    end; {if}
    i := i + 1;
  end; {while}
  WriteLn;
end; {Test}

var StZap, i, c: integer;
begin {Bloki}
  if ParamCount > 0 then 
    for i := 1 to ParamCount do begin
      Val(ParamStr(i), StZap, c);
      Test(StZap);
    end
  else begin
    Write('Vnesi tevilko bloka: ');
    ReadLn(StZap); Test(StZap);
  end; {if}
end. {Bloki}
