program Kodiranje; { RTK 1989.2.2 }
type 
  Ver = array[1..26] of record
    c: char; { rka }
    v: real; { pogostost rke v anglekem besedilu, podana v odstotkih }
  end; {Ver}

procedure Desifriraj1(var f: text; v: Ver); 
var 
  Pog: array['a'..'z'] of integer; 
  VrstniRed: array[1..26] of char;
  Kod: array['a'..'z'] of char;
  c: char; i, j: integer;
begin
  { Pretejmo pogostosti rk v datoteki f. }
  for c := 'a' to 'z' do Pog[c] := 0;
  while not Eof(f) do begin 
    Read(f, c); 
    if (c >= 'a') and (c <= 'z') then 
      Pog[c] := Pog[c] + 1; 
  end; {while}
  { Uredimo rke po padajoi pogostosti. }
  for i := 1 to 26 do begin
    j := i - 1; c := Chr(Ord('a') + i - 1);
    while j >= 1 do
      if Pog[VrstniRed[j]] >= Pog[c] then break
      else begin VrstniRed[j + 1] := VrstniRed[j]; j := j - 1; end;
    VrstniRed[j + 1] := c;
  end; {for}
  { i-ta najpogosteja rka iz f naj se dekodira v
    i-to najpogostejo rko iz v. }
  for i := 1 to 26 do 
    Kod[VrstniRed[i]] := v[i].c;
  { Dekodirajmo zdaj vsebino datoteke. }
  Reset(f);
  while not Eof(f) do begin 
    Read(f, c); 
    if (c >= 'a') and (c <= 'z') then
      c := Kod[c]
    else if (c >= 'A') and (c <= 'Z') then
      c := Chr(Ord(Kod[Chr(Ord(c) - Ord('A') + Ord('a'))]) - Ord('a') + Ord('A'));
    Write(c);
  end; {while}
end; {Desifriraj1}

procedure Desifriraj2(var f: text; v: Ver); 
type Interval = record c: char; zg, sp: real end;
var 
  Int: array[1..26] of Interval; 
  Pog: array['a'..'z'] of real; 

  procedure IzracunajIntervale; 
  var i: integer; 
  begin
    for i := 2 to 25 do begin 
      Int[i].c := v[i].c; 
      Int[i].zg := v[i].v + (v[i -1].v - v[i].v) / 2; 
      Int[i].sp := v[i].v - (v[i].v - v[i + 1].v) / 2; 
    end; {for}
    Int[1].c := v[1].c; Int[1].sp := Int[2].zg; Int[1].zg := 100; 
    Int[26].c := v[26].c; Int[26].zg := Int[25].sp; Int[26].sp := 0;  
  end; {IzracunajIntervale} 

  procedure PrestejCrke; 
  var c: char; Vsota: real; 
  begin
    for c := 'a' to 'z' do Pog[c] := 0; 
    Vsota := 0; 
    while not Eof(f) do begin 
      Read(f, c); 
      if (c >= 'a') and (c <= 'z') then 
        begin Pog[c] := Pog[c] + 1; Vsota := Vsota + 1 end;
    end; {while}
    for c := 'a' to 'z' do 
      Pog[c] := 100 * Pog[c] / Vsota; 
  end; {PrestejCrke} 

  procedure Zamenjaj; 
  var c: char; 

    function VrniCrko(c: char): char; 
    var i: integer; Nasel: boolean; 
    begin
      Nasel := false; 
      VrniCrko := '?'; 
      i := 1; 
      while not Nasel and (i <= 26) do 
        if (Pog[c] >= Int[i].sp) and (Pog[c] <= Int[i].zg) then 
          begin Nasel := true; VrniCrko := Int[i].c end
        else i := i + 1; 
      if not Nasel then WriteLn('Ne najdem: ', c, ' ', Pog[c]:0:10);
    end; {VrniCrko} 

  begin
    while not Eof(f) do begin 
      Read(f, c); 
      if (c <= 'z') and (c >= 'a') then 
        Write(VrniCrko(c))
      else if (c <= 'Z') and (c >= 'A') then 
        Write(Chr(Ord(VrniCrko(Chr(Ord(c) - Ord('A') + Ord('a')))) - Ord('a') + Ord('A')))
      else
        Write(c);
    end; {while}
  end; {Zamenjaj} 

begin {Kodiranje}
  IzracunajIntervale; 
  PrestejCrke; 
  Reset(f); 
  Zamenjaj; 
end; {Desifriraj}

var v: Ver; f: text;
begin
  { Statistike iz Gibbonove Zgodovine zatona in propada
    Rimskega cesarstva (skupaj: 5180529 rk). }
  v[ 1].c := 'e'; v[ 1].v := 13.0287;
  v[ 2].c := 't'; v[ 2].v := 9.40296;
  v[ 3].c := 'a'; v[ 3].v := 7.85607;
  v[ 4].c := 'o'; v[ 4].v := 7.56328;
  v[ 5].c := 'i'; v[ 5].v := 7.49037;
  v[ 6].c := 's'; v[ 6].v := 6.75223;
  v[ 7].c := 'n'; v[ 7].v := 6.72026;
  v[ 8].c := 'r'; v[ 8].v := 6.26527;
  v[ 9].c := 'h'; v[ 9].v := 5.72100;
  v[10].c := 'd'; v[10].v := 4.13944;
  v[11].c := 'l'; v[11].v := 3.36082;
  v[12].c := 'c'; v[12].v := 3.20230;
  v[13].c := 'f'; v[13].v := 2.89092;
  v[14].c := 'u'; v[14].v := 2.83923;
  v[15].c := 'm'; v[15].v := 2.50642;
  v[16].c := 'p'; v[16].v := 2.31422;
  v[17].c := 'y'; v[17].v := 1.51048;
  v[18].c := 'b'; v[18].v := 1.47234;
  v[19].c := 'w'; v[19].v := 1.47209;
  v[20].c := 'g'; v[20].v := 1.42541;
  v[21].c := 'v'; v[21].v := 1.09456;
  v[22].c := 'x'; v[22].v := 0.318732;
  v[23].c := 'k'; v[23].v := 0.260089;
  v[24].c := 'j'; v[24].v := 0.181564;
  v[25].c := 'q'; v[25].v := 0.139465;
  v[26].c := 'z'; v[26].v := 0.0717494;

  { V datoteki rtk89s2n2.in je zakodiran prvi razdelek 
    prvega poglavja Gibbonove Zgodovine. }
  Assign(f, 'rtk89s2n2.in');
  Reset(f); Desifriraj1(f, v);
  WriteLn('----------------------------------------');
  Reset(f); Desifriraj2(f, v);
  Close(f);
end. {Kodiranje}
