program IskanjePoOmrezju; { RTK 1990.1.1 }
const 
  MaxRac = 1000;      { najveje tevilo raunalnikov v mrei } 
  MaxSosedi = 20;     { najveje tevilo povezav } 
type 
  ImeT = packed array[1..8] of char; 
  SosediT = array[1..MaxSosedi] of integer; 
var 
  SpisekL: integer;       { tevilo raunalnikov na spisku } 
  Spisek: array[1..MaxRac] of record  { spisek raunalnikov v mrei } 
      Stevilka: integer;  { tevilka raunalnika --- naslov } 
      Ime: ImeT;          { ime raunalnika } 
  end; {Spisek}
  
  function KdoSem: integer; forward; 
  procedure Vprasaj(Naslov: integer; var Ime: ImeT; 
    var Sosedi: SosediT; var SosediL: integer); forward; 

procedure NajdiVozlisca; 
var 
  Sosedi: SosediT; 
  p, st, j, SosediL: integer; 
begin
  { V spisek najprej vstavimo sebe. } 
  SpisekL := 1; Spisek[SpisekL].Stevilka := KdoSem; St := 1; 
  while st <= SpisekL do begin 
    { Obdelamo vse sosede raunalnika st. } 
    Vprasaj(Spisek[st].Stevilka, Spisek[st].Ime, Sosedi, SosediL); 
    for p := 1 to SosediL do begin 
      { Za vsak raunalnik iz Sosedi[st] pogledamo, ali je e v spisku. } 
      j := 1; Spisek[SpisekL + 1].Stevilka := Sosedi[p]; 
      while Sosedi[p] <> Spisek[j].Stevilka do j := j + 1; 
      if j > SpisekL then SpisekL := SpisekL + 1; 
    end; {for}
    WriteLn(Spisek[st].Stevilka:4, ' ', Spisek[st].Ime); 
    st := st + 1; 
  end; {while}
end; {NajdiVozlisca} 

{-----------------------------------------------------------------------------}
{ Sledi implementacija zgoraj obljubljenih podprogramov KdoSem in Vprasaj.    }
{ Podatke o omreju preberemo kar s standardnega vhoda.                       }
{-----------------------------------------------------------------------------}

var 
  SosediVseh: array[1..MaxRac] of SosediT;
  StSosedov: array[1..MaxRac] of integer;
  NasaStevilka: integer;

{ Prebere opis omreja s standardnega vhoda.  
  Za vsak raunalnik naj bo podana tevilka raunalnika in
  nato tevilke njegovih sosedov ter na koncu tevilo 0.
  Na koncu vseh podatkov za vse raunalnike naj bo e
  eno tevilo 0 in nato tevilka naega raunalnika. }
procedure PreberiOpis;
var StRac, Sosed: integer;
begin
  for StRac := 1 to MaxRac do StSosedov[StRac] := -1;
  while True do begin
    Read(StRac); if StRac <= 0 then break;
    StSosedov[StRac] := 0;
    while True do begin
      Read(Sosed); if Sosed <= 0 then break;
      Assert(StSosedov[StRac] < MaxSosedi);
      StSosedov[StRac] := StSosedov[StRac] + 1;
      SosediVseh[StRac, StSosedov[StRac]] := Sosed;
    end; {while}
  end; {while}
end; {PreberiOpis}

function KdoSem: integer; 
begin
  KdoSem := NasaStevilka;
end; {KdoSem}

procedure Vprasaj(Naslov: integer; var Ime: ImeT; 
  var Sosedi: SosediT; var SosediL: integer); 
var S: string;
begin
  Assert((1 <= Naslov) and (Naslov <= MaxRac));
  Assert(StSosedov[Naslov] >= 0);
  Str(Naslov, S); Ime := 'Rac' + S;
  Sosedi := SosediVseh[Naslov];
  SosediL := StSosedov[Naslov];
end; {Vprasaj}

begin {IskanjePoOmrezju}
  PreberiOpis;
  for NasaStevilka := 1 to MaxRac do 
    if StSosedov[NasaStevilka] >= 0 then begin
      WriteLn('Raunalniki, dosegljivi od raunalnika ', NasaStevilka, ':');
      NajdiVozlisca;
    end; {if}
end. {IskanjePoOmrezju}
