program MarvinovVodic(Input, Output); { RTK 1990.2.1 }
const MaxN = 10;       { najveja dimenzija kvadra } 
type DimenzijeT = array[1..MaxN] of integer; 

{ Sprehod skozi celice n-dimenzionalnega kvadra s stranicami Dolz. } 
procedure Obhod(n: integer; var Dolz: DimenzijeT); 
var i, j, k, m: integer; 
begin
  m := 1; for j := 1 to n do m := m * Dolz[j]; 
  for i := 0 to m - 1 do begin 
    k := i; 
    for j := 1 to n do 
      begin Write((k mod Dolz[j] + 1):3); k := k div Dolz[j] end;
    WriteLn;
  end; {for}
end; {Obhod} 

{ Sprehod skozi celice n-dimenzionalnega kvadra s stranicami Dolz,
  pri emer gremo vedno iz trenutne celice v eno od njenih 
  neposrednih sosed. } 
procedure ZaLenobe(n: integer; var Dolz: DimenzijeT);
var
  Koord: DimenzijeT;   { koordinate pregledovane kockice } 
  Raste: array[1..MaxN] of boolean;   { tevec v tej koordinati raste } 
  Konec: boolean;      { konec korakanja } 
  Prenos: boolean;     { stopiti moramo e po naslednji koordinati } 
  i: integer;          { tevec } 
begin
  for i := 1 to n do begin Koord[i] := 1; Raste[i] := true end; { zaetek } 
  repeat 
    for i := 1 to n do Write(Koord[i]:3);  WriteLn; { izpiemo, kje smo } 
    i := 0; Konec := false; 
    repeat 
      Prenos := false; i := i + 1; { stopimo po i-ti koordinati } 
      if i > n then Konec := true  { prenos iz zadnjega mesta pomeni konec poti } 
      else if Raste[i] then begin 
        if Koord[i] < Dolz[i] then Koord[i] := Koord[i] + 1 { naprej } 
        else begin Raste[i] := not Raste[i]; Prenos := true end;
      end
      else begin 
        if Koord[i] > 1 then Koord[i] := Koord[i] - 1       { nazaj } 
        else begin Raste[i] := not Raste[i]; Prenos := true end;
      end; {if}
      { e je Prenos = true, moramo stopiti e po koordinati i + 1. } 
    until not Prenos; 
  until Konec; 
end; {ZaLenobe}

var 
  n: integer;       { dimenzija kvadra } 
  Dolz: DimenzijeT; { dimenzije stranic } 
  j: integer;       { tevec po dimenzijah } 
  c: char;
begin {MarvinovVodic} 
  Write('Dimenzija kvadra: '); ReadLn(n); 
  WriteLn('Velikosti stranic'); 
  for j := 1 to n do begin Write(j, ': '); ReadLn(Dolz[j])end;; 
  Write('Si lenoba (d/n)? '); ReadLn(c);
  if UpCase(c) = 'D' then ZaLenobe(n, Dolz)
  else Obhod(n, Dolz);
end. {MarvinovVodic} 
