program Vracanje(Input, Output); { RTK 1991.1.2 }
type 
  UkazT = (Vrni, Ponovi, Vleci, Konec); 
  PotezaT = string; 

  { Ta podprogram bere ukaze s standardnega vhoda.
    'Poteza' bo pri nas kar navaden niz znakov. }
  procedure BeriUkaz(var Ukaz: UkazT; var Poteza: PotezaT); 
  var S, UkazS: string; i, j: integer;
  begin
    ReadLn(S);
    { Ukaz je naeloma ena beseda, razen pri ukazu
      'vleci', ki mu sledi e presledek in opis poteze. }
    i := 1; while i <= Length(S) do if S[i] = ' ' then break else i := i + 1;
    j := i; while j <= Length(S) do if S[j] = ' ' then j := j + 1 else break;
    UkazS := Copy(S, 1, i - 1);
    Poteza := Copy(S, j, Length(S) - j + 1);
    if UkazS = 'vrni' then Ukaz := Vrni
    else if UkazS = 'ponovi' then Ukaz := Ponovi
    else if UkazS = 'vleci' then Ukaz := Vleci
    else if UkazS = 'konec' then Ukaz := Konec;
  end; {BeriUkaz}

type
  IgranaP = ^IgranaT;
  IgranaT = record
    Poteza: PotezaT;
    Prejsnja: IgranaP;
  end; {IgranaT}
var 
  { Seznam doslej odigranih (in e ne vrnjenih) potez.
    Uporablja ga VrniPotezo, da preverja, e glavni del programa
    ne dela neumnosti.  'Odigrane' kae na zadnjo potezo,
    do predhodnih pa se prikopljemo prek kazalcev Prejsnja. }
  Odigrane: IgranaP;

  procedure IgrajPotezo(Poteza: PotezaT); 
  var P: IgranaP;
  begin
    New(P); P^.Poteza := Poteza; 
    P^.Prejsnja := Odigrane; Odigrane := P;
    WriteLn('IgrajPotezo ', Poteza);
  end; {IgrajPotezo}

  { Tale podprogram e preveri, e je dana poteza res tista,
    ki smo jo nazadnje odigrali.  e to ne dri, pomeni, da
    klicatelj uporablja ta podprogram drugae, kot dopua
    besedilo naloge. }
  procedure VrniPotezo(Poteza: PotezaT); 
  var P: IgranaP;
  begin
    Write('VrniPotezo  ', Poteza);
    if Odigrane = nil then
      WriteLn('Napaka: nobena poteza e ni bila odigrana.')
    else if Odigrane^.Poteza <> Poteza then
      WriteLn('Napaka: zadnja odigrana je bila ', Odigrane^.Poteza, '.')
    else begin
      P := Odigrane^.Prejsnja;
      Dispose(Odigrane); Odigrane := P;
      WriteLn;
    end; {if}
  end; {VrniPotezo}

const 
  PotezaM = 10; { tevilo shranjenih potez } 
var 
  Poteza: array[1..PotezaM] of PotezaT; { shranjene poteze } 
  PotezaL: integer;       { tevilo shranjenih potez } 
  Zadnja: integer;        { tevilka zadnje veljavne poteze v shrambi } 
  { Pri vleenju novih potez velja Zadnja = PotezaL,  
    sicer pa se lahko spremenljivka Zadnja vraa po shranjenih potezah. }
  Ukaz: UkazT;           { ahistov ukaz } 
  p: PotezaT;            { ahistova poteza, e je Ukaz = Vleci } 
  i: integer; 

begin {Vracanje}
  PotezaL := 0; Zadnja := 0; 
  repeat 
    
    Write('Shramba:');
    for i := 1 to PotezaL do begin 
      Write(' '); if Zadnja = i - 1 then Write('| ');
      Write(Poteza[i]); 
    end; {for}
    WriteLn(' (', Zadnja, '/', PotezaL, ')');
    
    BeriUkaz(Ukaz, p); 
    case Ukaz of 
      Vrni: 
        if Zadnja > 0 then 
          begin VrniPotezo(Poteza[Zadnja]); Zadnja := Zadnja - 1 end; 
      Ponovi: 
        if Zadnja < PotezaL then 
          begin Zadnja := Zadnja + 1; IgrajPotezo(Poteza[Zadnja]) end; 
      Vleci: 
        begin
          PotezaL := Zadnja; { Zavremo morebitne e shranjene noveje poteze. } 
          if PotezaL < PotezaM then { V shrambi je prostor. } 
            PotezaL := PotezaL + 1 
          else { Ni prostora, zavremo najstarejo shranjeno potezo. } 
            for i := 2 to PotezaL do Poteza[i - 1] := Poteza[i]; 
          Poteza[PotezaL] := p; Zadnja := PotezaL; IgrajPotezo(p); 
        end; 
    end; {case} 
  until Ukaz = Konec; 
end. {Vracanje} 
