program PrekladanjePapirjev; { RTK 1992.2.2 }
uses Crt;
type Kup = (A, B, M);

{ Vmesnik, ki ga vidijo podprogrami ShraniPapir*/VzemiPapir*. }
function Prazen(k: Kup): boolean; forward;
procedure Snemi(k: Kup); forward;
procedure Nalozi(k: Kup); forward;

{ Podprogram preloi vse, kar je na kupu OdKod, 
  na kup Kam po en papir naenkrat. 
  Pri tem se vrstni red papirjev ravno obrne. }
procedure Prekucni(OdKod, Kam: Kup); 
begin
  while not Prazen(OdKod) do begin 
    Snemi(OdKod); 
    Nalozi(Kam); 
  end; {while}
end; {Prekucni} 

{-----------------------------------------------------------------------------}

procedure ShraniPapir1; 
begin
  Snemi(M); Nalozi(A); 
end; {ShraniPapir1} 

procedure VzemiPapir1; 
begin
  Prekucni(A, B); 
  Snemi(B); Nalozi(M); 
  Prekucni(B, A); 
end; {VzemiPapir1} 

{-----------------------------------------------------------------------------}

procedure ShraniPapir2; 
begin
  Prekucni(B, A); 
  Snemi(M); Nalozi(A); 
end; {ShraniPapir2} 

procedure VzemiPapir2; 
begin
  Prekucni(A, B); 
  Snemi(B); Nalozi(M); 
end; {VzemiPapir2} 

{-----------------------------------------------------------------------------}

procedure ShraniPapir3; 
begin
  Snemi(M); Nalozi(A); 
end; {ShraniPapir3} 

procedure VzemiPapir3; 
begin
  if Prazen(B) then Prekucni(A, B); 
  Snemi(B); Nalozi(M); 
end; {VzemiPapir3} 

{-----------------------------------------------------------------------------}

function PraznoSkladisce: boolean; 
begin
  PraznoSkladisce := Prazen(A) and Prazen(B); 
end; {PraznoSkladisce} 

{-----------------------------------------------------------------------------}

type
  ClenP = ^ClenT;
  ClenT = record
    i: integer;
    Nasl: ClenP;
  end; {ClenT}
const Ime: array[Kup] of string = ('A', 'B', 'M');
var
  { Za vsak kup imamo verigo -- Kupi[k] kae na papir,
    ki je na vrhu kupa.  Kupi[M] je kup papirjev, ki smo 
    jih odloili na Bertovo mizo.  Za Warovo mizo pa si 
    mislimo, da vsebuje neskonen kup papirjev (na vrhu 
    je 1, pod njim 2, 3, 4 in tako naprej). }
  Kupi: array[Kup] of ClenP;
  { vRoki = 0, e robot nima v roki nobenega papirja.
    WarNasl je naslednji papir, ki bo priel z Warove mize. }
  vRoki, WarNasl: integer;

{ k = M pomeni, da bo vzel naslednji Warov papir.
  Ti so otevileni kar od 1 naprej (WarNasl pove,
  kateri bo naslednji na vrsti). }
procedure Snemi(k: Kup);
var P: ClenP;
begin
  Write('Snemi(', Ime[k], ') ');
  if vRoki > 0 then begin WriteLn('Napaka: v roki e drim papir ', vRoki, '.'); exit; end;
  if k = M then begin
    vRoki := WarNasl; WarNasl := WarNasl + 1; 
  end else if Kupi[k] = nil then begin
    WriteLn('Napaka: kup ', Ime[k], ' je prazen.'); exit;
  end else begin
    vRoki := Kupi[k]^.i;
    P := Kupi[k]^.Nasl; Dispose(Kupi[k]);
    Kupi[k] := p;
  end; {if}
  WriteLn(' --> ', vRoki);
end; {Snemi}

procedure Nalozi(k: Kup);
var P: ClenP;
begin
  Write('Nalozi(', Ime[k], ') ');
  if vRoki <= 0 then begin WriteLn('Napaka: v roki ne drim nobenega papirja.'); exit; end;
  WriteLn(' <-- ', vRoki);
  New(P); P^.Nasl := Kupi[k]; 
  P^.i := vRoki; vRoki := 0;
  Kupi[k] := p;
end; {Nalozi}

function Prazen(k: Kup): boolean;
begin
  Prazen := (k <> M) and (Kupi[k] = nil);
end; {Prazen}

procedure IzpisiKup(S: string; P: ClenP);
begin
  Write(S);
  while P <> nil do begin
    Write(' ', P^.i); 
    P := P^.Nasl;
  end; {while}
  WriteLn;
end; {IzpisiKup}

procedure Pocisti(P: ClenP);
var Nasl: ClenP;
begin
  while P <> nil do begin
    Nasl := P^.Nasl;
    Dispose(P); P := Nasl;
  end; {while}
end; {Pocisti}

var Shrani, Vzemi: procedure; Alg, i: integer; c: char;
begin {PrekladanjePapirjev}

  { Inicializacija. }
  Kupi[A] := nil; Kupi[B] := nil; Kupi[M] := nil;
  vRoki := 0; WarNasl := 1;

  { Prvi parameter na ukazni vrstici nam pove, kateri
    algoritem naj izvajamo. }
  Alg := 1;
  if ParamCount >= 1 then begin
    Val(ParamStr(1), Alg, i);
    if i > 0 then Alg := 1;
  end; {if}
  
  case Alg of
  2: begin Shrani := @ShraniPapir2; Vzemi := @VzemiPapir2; end;
  3: begin Shrani := @ShraniPapir3; Vzemi := @VzemiPapir3; end;
  else begin Shrani := @ShraniPapir1; Vzemi := @VzemiPapir1; end;
  end; {case}

  WriteLn('Simulator birokracije');
  WriteLn('S = shrani papir (robot ga vzame z Warove mize),');
  WriteLn('V = vzemi papir (robot da papir na Bertovo mizo),');
  WriteLn('Q ali X = izhod.');
  WriteLn('Algoritem (podan v ukazni vrstici): ', Alg);
  WriteLn;
  
  while true do begin
    
    IzpisiKup('   Kup A:', Kupi[A]);
    IzpisiKup('   Kup B:', Kupi[B]);
    IzpisiKup('   Bertov kup:', Kupi[M]);
    Write('   V roki: '); if vRoki = 0 then Write('ni') else Write(vRoki);
    WriteLn('.  Naslednji Warov papir bo: ', WarNasl, '.');
    
    c := UpCase(ReadKey); 
    case c of
      'Q', 'X': break;
      'V': Vzemi;
      'S': Shrani;
      #0: c := ReadKey;
    end; {case}
    
  end; {while}
  
  Pocisti(Kupi[A]); Pocisti(Kupi[B]); Pocisti(Kupi[M]);
  
end. {PrekladanjePapirjev}
