program Morse(Input, Output); { RTK 1993.2.4 }
type CasT = integer; 

const MaxPiskov = 300;
type 
  PiskT = record
    CasOd, CasDo: CasT;
  end; {PiskT}
var Piski: array[1..MaxPiskov] of PiskT;
    TrenPisk, StPiskov: integer;
    TrenCas, Stoparica: CasT;

{ V tabeli Piski pripravi piske, s katerimi je predstavljen niz S. 
  Pri tem upoteva tudi, da se osnovna enota trajanja piskov
  (in pavz) sasoma poasi spreminja in da lahko tudi
  posamezni piski (ali pavze) malo odstopajo od prave doline. }
procedure PripraviPiske(S: string);
const MorsejevKod: array['A'..'Z'] of string = (
  '._', '_...', '_._.', '_..', '.', '.._.', '__.', '....', '..', '.___', 
  '_._', '._..', '__', '_.', '___', '.__.', '__._', '._.', '...', '_', 
  '.._', '..._', '.__', '_.._', '_.__', '__..' );
var i, j: integer; Enota, Cas: CasT; c: char; T: string;

  procedure SpremeniEnoto;
  begin
    if Random(2) = 1 then Enota := Enota + 10 
    else if Enota > 30 then Enota := Enota - 10;
  end; {SpremeniEnoto}
  
  procedure DodajPisk(Trajanje: integer);
  begin
    StPiskov := StPiskov + 1;
    Piski[StPiskov].CasOd := Cas;
    Cas := Cas + Trajanje;
    Piski[StPiskov].CasDo := Cas;
    SpremeniEnoto;
  end; {DodajPisk}
  
  procedure DodajPavzo(Trajanje: integer);
  begin
    Cas := Cas + Trajanje;
    SpremeniEnoto;
  end; {DodajPavzo}

begin {PripraviPiske}
  WriteLn('Morsejeva predstavitev niza "', S, '":');
  TrenPisk := 1; StPiskov := 0; Enota := 200; 
  TrenCas := 0; Cas := Random(300);
  for i := 1 to Length(S) do begin
    c := UpCase(S[i]);
    if c in ['A'..'Z'] then begin
      T := MorsejevKod[c]; Write(T, ' ');
      for j := 1 to Length(T) do begin
        { Dodajmo pisk za ta znak (piko ali rtico). }
        if T[j] = '.' then DodajPisk(Enota)
        else DodajPisk(3 * Enota + Random(Enota div 2) - Enota div 4);
        { Dodajmo presledek za piskom. }
        if j < Length(T) then DodajPavzo(Enota);
      end; {for j}
    end; {if}
    { Kaj je za to rko?  e je rka, dodajmo krajo
      pavzo, e je presledek, pa dolgo pavzo. }
    if i = Length(S) then c := ' '
    else c := UpCase(S[i + 1]);
    if c in ['A'..'Z'] then DodajPavzo(3 * Enota + Random(Enota div 2) - Enota div 4)
    else begin WriteLn; DodajPavzo(6 * Enota + Random(Enota) - Enota div 2); end;
  end; {for i}
  WriteLn('tevilo piskov: ', StPiskov);
  Cas := 0; Stoparica := 0;
end; {PripraviPiske}

procedure Start;
  begin Stoparica := TrenCas; end;
function Cas: integer;
  begin Cas := TrenCas - Stoparica; end;

function Piska: boolean;
begin
  if TrenPisk > StPiskov then Halt;
  while TrenPisk <= StPiskov do
    if TrenCas >= Piski[TrenPisk].CasDo then TrenPisk := TrenPisk + 1
    else break;
  if TrenPisk > StPiskov then Piska := false
  else Piska := TrenCas >= Piski[TrenPisk].CasOd;
  TrenCas := TrenCas + 1;
end; {Piska}

{-----------------------------------------------------------------------------}
{ Spodaj je tisti del programa, ki ga zares zahteva naloga.                   }
{-----------------------------------------------------------------------------}

const Pika = '.'; 
      Crta = '_'; 
var 
  dt: CasT;       { izmerjeni asovni interval } 
  dt1: CasT;      { referenna osnovna enota --- trajanje pike } 
  ndt1: CasT;     { osnovna enota, kot smo jo izmerili pri zadnjem znaku } 
  Utez: integer;  { stopnja nespremenljivosti referenne enote } 
  p: boolean; 
  Znak: char; 
  S: string; i: integer;
begin {Morse}

  if ParamCount >= 1 then begin
    S := '';
    for i := 1 to ParamCount do begin
      if i > 1 then S := S + ' ';
      S := S + ParamStr(i);
    end; {for i}
  end else S := 'SPREJEM MORSEJEVE ABECEDE';
  PripraviPiske(S);
  WriteLn('Iz piskov pa program razbere naslednje:');
  
  repeat until not Piska; 
  dt1 := 0; Utez := 0; 
  while true do begin 
    repeat until Piska; { poakamo zaetek piska } 
    Start; 
    repeat until not Piska; { poakamo konec piska } 
    dt := Cas; 
    Start; 
    if dt < 2 * dt1   { primerjamo trajanje piska z referenco } 
      then begin Znak := Pika; ndt1 := dt; end        { pika traja eno enoto } 
      else begin Znak := Crta; ndt1 := dt div 3; end; { rtica traja tri enote } 
    Write(Znak); 
    dt1 := (Utez * dt1 + ndt1) div (Utez + 1);  { prilagodimo asovno enoto } 
    if Utez < 5 then Utez := Utez + 1;          { referenna enota postaja zanesljiveja } 
    { poakamo zaetek piska ali dovolj dolgo, da velja konec rke } 
    repeat p := Piska until p or (Cas > 2 * dt1); 
    if not p then Write(' '); 
    { poakamo zaetek piska ali dovolj dolgo, da velja konec besede } 
    repeat p := Piska until p or (Cas > 5 * dt1); 
    if not p then WriteLn; 
  end; {while}
  
end. {Morse} 
