program UraSKazalci; { RTK 1994.1.3 }
uses Dos, Graph, Crt; 
var 
  PeroX, PeroY: integer; 
  Ura, Minuta, Sekunda, NovaUra, NovaMinuta, NovaSekunda: integer; 

procedure Cas(var Ura, Minuta, Sekunda: integer); 
var WUra, WMinuta, WSekunda, WStotinka: word; 
begin
  GetTime(WUra, WMinuta, WSekunda, WStotinka); 
  Ura := WUra; Minuta := WMinuta; Sekunda := WSekunda; 
end; {Cas} 

procedure OdpriGraficniNacin; 
var GDrv, GMode: integer; 
begin
  GDrv := Detect; InitGraph(GDrv, GMode, 'c:\bp\bgi'); 
  if GraphResult <> grOk then Halt(1); 
  PeroX := 1; PeroY := 1; SetColor(White);
end; {OdpriGraficniNacin} 

procedure ZapriGraficniNacin; 
begin
  CloseGraph; 
end; {ZapriGraficniNacin} 

procedure PojdiNa(X, Y: integer); 
begin
  PeroX := X; PeroY := Y; 
end; {PojdiNa} 

procedure Naprej(K: real; D: integer); 
var NoviPeroX, NoviPeroY: integer; 
begin
  NoviPeroX := PeroX + Round(D * Cos(Pi * (K - 90) / 180)); 
  NoviPeroY := PeroY + Round(D * Sin(Pi * (K - 90) / 180)); 
  Line(PeroX, PeroY, NoviPeroX, NoviPeroY); 
  PeroX := NoviPeroX; PeroY := NoviPeroY; 
end; {Naprej} 

procedure Pisi(Stevilo: integer); 
var Niz: string; 
begin
  Str(Stevilo, Niz); 
  OutTextXY(Trunc(Round(PeroX - 0.5 * TextWidth(Niz))), 
            Trunc(Round(PeroY - 0.5 * TextHeight(Niz))), Niz);
end; {Pisi} 

procedure Risi; 
  begin SetColor(White); end;

procedure Brisi; 
  begin SetColor(Black); end;
  
var
  Sirina, Visina, X0, Y0, R: integer;
  KazU, KazM, KazS: integer; { doline kazalcev }
begin {UraSKazalci} 

  OdpriGraficniNacin; 
  Sirina := GetMaxX + 1; Visina := GetMaxY + 1; { velikost zaslona }
  X0 := Sirina div 2; Y0 := Visina div 2; { sredie zaslona (in ure) }
  if X0 > Y0 then R := Y0 else R := X0; 
  R := Trunc(Round(0.95 * R)); { to bo zunanji polmer ure }
  { Doloimo velikost kazalcev. }
  KazU := 10 * R div 20; KazM := 12 * R div 20; KazS := 13 * R div 20;
  
  SetTextStyle(DefaultFont, HorizDir, 3);
  for Ura := 1 to 12 do begin
    PojdiNa(X0, Y0); 
    Brisi; Naprej(Ura * 30, 14 * R div 20); 
    Risi; Naprej(Ura * 30, 2 * R div 20); 
    Brisi; Naprej(Ura * 30, R div 20); 
    Risi; Pisi(Ura); 
  end; {for}

  Cas(Ura, Minuta, Sekunda); 
  while not KeyPressed do begin
    Risi; 
    PojdiNa(X0, Y0); Naprej((Ura + Minuta / 60) * 30, KazU); 
    PojdiNa(X0, Y0); Naprej(Minuta * 6, KazM); 
    PojdiNa(X0, Y0); Naprej(Sekunda * 6, KazS); 

    repeat 
      Cas(NovaUra, NovaMinuta, NovaSekunda); 
    until NovaSekunda <> Sekunda; 

    Brisi; 
    PojdiNa(X0, Y0); Naprej((Ura + Minuta / 60) * 30, KazU); 
    PojdiNa(X0, Y0); Naprej(Minuta * 6, KazM); 
    PojdiNa(X0, Y0); Naprej(Sekunda * 6, KazS); 
    Ura := NovaUra; Minuta := NovaMinuta; Sekunda := NovaSekunda; 
  end; {while}

  ZapriGraficniNacin; 
end. {UraSKazalci} 
