program Znamke; { RTK 1994.3.2 }
const NajvecjiNiz = 255; 
type 
  NizT = array[1..NajvecjiNiz] of integer; 
  { PostnineT[1] je v bistvu seznam delnih potnin. 
    PostnineT[2, i] je vrednost zadnje znamke, ki smo jo dodali
    pri tvorjenju potnine, da smo dobili potnino PostnineT[1, i]. }
  PostnineT = array[1..2] of NizT; 
  MnozicaT = set of 1..NajvecjiNiz; 
var 
  VrednostiZnamk : NizT;       { vrednosti znamk, iz katerih sestavljamo potnino } 
  NizZnamk: NizT;              { niz vrednosti znamk, ki tvorijo potnino } 
  Postnine: PostnineT;         { delne potnine in zadnje dodane znamke } 
  Postnina: integer;           { potnina, ki jo elimo pokriti } 
  Presezek: integer;           { najmanji dosedanji preseek preko potnine } 
  OstanekPostnine: integer;    { potnina brez zadnje znamke } 
  PokriteVrednosti: MnozicaT;  { potnine, ki smo jih pokrili } 

procedure BeriNizVrednosti(var Niz: NizT); 
var i: integer; 
begin
  i := 1; 
  while not Eoln do 
    begin Read(Niz[i]); i := i + 1; end;
  ReadLn; 
  Niz[i] := -1; 
end; {BeriNizVrednosti} 

procedure Inicializacija; 
var i : integer; 
begin
  { Izraunajmo najveji moni preseek: to je kar vrednost 
    najdraje znamke, kajti gotovo se da sestaviti potnino,
    ki eljeno vrednost presega kvejemu za vrednost ene znamke. }
  Presezek := VrednostiZnamk[1]; 
  i := 2; 
  while VrednostiZnamk[i] <> -1 do begin 
    if Presezek > VrednostiZnamk[i] then 
      Presezek := VrednostiZnamk[i]; 
    i := i + 1; 
  end; {while}
  { Na zaetku ni pokrita e nobena potnina. } 
  PokriteVrednosti := []; 
  Postnine[1, 1] := 0; Postnine[1, 2] := -1; 
  NizZnamk[1] := -1; 
end; {Inicializacija} 

procedure NajdiNizZnamk(TrenPostnine: PostnineT; PokriteVrednosti: MnozicaT;
                        var OstanekPostnine: integer; 
                        var NizZnamk: NizT; IndeksZnamke: integer); 
var NovePostnine: PostnineT; 
    TrenPostnina: integer; 
    i, j, k: integer; 
begin
  if (TrenPostnine[1, 1] <> -1) and (Presezek > 0) then begin
    i := 1; k := 1; 
    while TrenPostnine[1, i] <> -1 do begin 
      { Za vsako trenutno potnino naredimo vse mone "naslednice",
        ki jih lahko dobimo, e ji dodamo novo znamko. } 
      j := 1; 
      while VrednostiZnamk[j] <> -1 do begin 
        { Izraunamo naslednico trenutne potnine. } 
        TrenPostnina := TrenPostnine[1, i] + VrednostiZnamk[j]; 
        if not (TrenPostnina in PokriteVrednosti) then begin
          { Trenutna potnina e ni pokrita. } 
          PokriteVrednosti := PokriteVrednosti + [TrenPostnina]; 
          if TrenPostnina < Postnina + Presezek then begin
            { Trenutna potnina ne presega trenutno najbolje reitve. } 
            NovePostnine[1, k] := TrenPostnina; 
            NovePostnine[2, k] := VrednostiZnamk[j]; 
            k := k + 1; 
            if TrenPostnina >= Postnina then 
              { Trenutna potnina je izboljala preseek- } 
              Presezek := TrenPostnina - Postnina; 
          end; {if}
        end; {if}
        j := j + 1; 
      end; {while}
      i := i + 1; 
    end; {while}
    NovePostnine[1, k] := -1; 

    { Rekurzivni klic podprograma z novimi potninami. } 
    NajdiNizZnamk(NovePostnine, PokriteVrednosti, OstanekPostnine, 
                  NizZnamk, IndeksZnamke + 1); 

    if NovePostnine[1, 1] <> -1 then begin
      { Poglejmo, katera znamka, dodana v tem koraku, 
        vodi do najbolje potnine. } 
      i := 1; 
      while NovePostnine[1, i] <> OstanekPostnine do i := i + 1; 
      NizZnamk[IndeksZnamke] := NovePostnine[2, i]; 
      OstanekPostnine := OstanekPostnine - NovePostnine[2, i]; 
    end else begin 
      { Smo v najbolj zunanjem rekurzivnem klicu, torej smo nateli 
        e vse znamke v tej potnini. }
      NizZnamk[IndeksZnamke] := -1;    
    end; {if}
  end 
  
  else begin 
    { Prejnji rekurzivni klic ni ustvaril nobene nove potnine, torej 
      se lahko nae iskanje kona; rekonstruirajmo znamke v najbolji 
      najdeni reitvi. }
    OstanekPostnine := Postnina + Presezek; 
    NizZnamk[IndeksZnamke] := -1; 
  end; {if}
end; {NajdiNizZnamk} 

procedure IzpisiNizZnamk(NizZnamk: NizT); 
var i : integer; 
begin
  i := 1; 
  while NizZnamk[i] <> -1 do 
    begin Write(NizZnamk[i], ' '); i := i + 1; end;
  WriteLn; 
end; {IzpisiNizZnamk} 

begin {Znamke} 
  BeriNizVrednosti(VrednostiZnamk); 
  while not Eof do begin
    ReadLn(Postnina); 
    Inicializacija; 
    NajdiNizZnamk(Postnine, PokriteVrednosti, OstanekPostnine, NizZnamk, 1); 
    WriteLn('Najugodneji nabor znamk za potnino ', Postnina, ':');
    IzpisiNizZnamk(NizZnamk); 
  end; {while}
end. {Znamke} 
