program SimulatorVrat; { RTK 1994.3.3 }
uses Crt;

type MotorT = (Stoj, Odpiraj, Zapiraj); 

  function OdprtostVrat: real; forward; 
  function IzstopPesec: boolean; forward; 
  function IzstopAvto: boolean; forward; 
  function Vstop: boolean; forward; 
  function Ovira: boolean; forward; 
  procedure Motor(Ukaz: MotorT); forward; 
  procedure NastaviBudilko(s: integer); forward; 
  function PreostaliCas: integer; forward; 
  { Tega podprograma naloga ne omenja.  Tekmovalev podprogram
    Vrata naj ga obasno poklie, da bo osveil prikaz na zaslonu. }
  function NajKoncam: boolean; forward; 

procedure Vrata;
var 
  MinSirina: real; 
  Ukaz, StanjeMotorja: MotorT; 
  UraTece: boolean; 
begin
  MinSirina := 0; UraTece := false; 
  StanjeMotorja := Stoj; Motor(Stoj); 
  repeat 
    
    Ukaz := StanjeMotorja; 
    if Vstop or IzstopAvto then 
      begin Ukaz := Odpiraj; MinSirina := 1; end; 
    if IzstopPesec and ((MinSirina = 0) or (Ukaz = Zapiraj)) then begin 
      if MinSirina = 0 then MinSirina := 0.5;
      Ukaz := Odpiraj; 
    end; {if}
    if Ovira and (OdprtostVrat > 0) then Ukaz := Odpiraj; 
    if UraTece and (PreostaliCas = 0) then 
      begin Ukaz := Zapiraj; UraTece := false; end; 
    
    if (Ukaz = Odpiraj) and (OdprtostVrat >= MinSirina) then Ukaz := Stoj; 
    if (Ukaz = Zapiraj) and (OdprtostVrat = 0) then 
      begin Ukaz := Stoj; MinSirina := 0; end; 
    if Ukaz <> StanjeMotorja then begin
      Motor(Ukaz); StanjeMotorja := Ukaz; 
      if (Ukaz = Stoj) and (OdprtostVrat > 0) then 
        begin NastaviBudilko(15); UraTece := true; end; 
    end; {if}
    
    if StanjeMotorja <> Stoj then 
      begin NastaviBudilko(0); UraTece := false; end; 
    if (StanjeMotorja = Stoj) and (OdprtostVrat > 0) and 
       (Vstop or IzstopAvto or IzstopPesec or Ovira) then  
      begin NastaviBudilko(15); UraTece := true; end; 
      
  until NajKoncam; 
end; {Vrata} 

{-----------------------------------------------------------------------------}
{ Preostanek programa simulira okolje, v katerem naj bi se izvajal            }
{ podprogram Vrata.                                                           }
{-----------------------------------------------------------------------------}

const SirinaVrat = 20;
      HitrostVrat = 3; { v enotah irine na sekundo }
var Cas, Budilka, { vsi asi so v milisekundah }
    CasVrat: integer; { kako dolgo so vrata e v trenutnem stanju }
    TipPesec, TipAvto, TipOvira, TipVstop: boolean; { stanje tipal }
    VrataX: real; { odprtost vrat }
    UkazMotorja: MotorT;

function OdprtostVrat: real; begin OdprtostVrat := VrataX / SirinaVrat; end;
function IzstopPesec: boolean; begin IzstopPesec := TipPesec; end;
function IzstopAvto: boolean; begin IzstopAvto := TipAvto; end;
function Vstop: boolean; begin Vstop := TipVstop; end;
function Ovira: boolean; begin Ovira := TipOvira; end;
procedure Motor(Ukaz: MotorT); begin UkazMotorja := Ukaz; end;
procedure NastaviBudilko(s: integer); begin Budilka := s * 1000; end;
function PreostaliCas: integer; begin PreostaliCas := (Budilka + 500) div 1000; end;

procedure PrikaziStanje;
var i, StZnakov: integer;
begin
  Write('[Tipala:');
  if TipPesec then Write(' peec') else Write('      ');
  if TipAvto then Write(' avto') else Write('     ');
  if TipOvira then Write(' ovira') else Write('      ');
  if TipVstop then Write(' vstop') else Write('      ');
  Write('] [Budilka: ', (Budilka / 1000.0):4:1, '] Vrata: ');
  case UkazMotorja of 
   Stoj: Write('  '); 
   Odpiraj: Write('<<'); 
   Zapiraj: Write('>>'); 
  end; {case}
  Write(' |');
  StZnakov := Round(SirinaVrat - VrataX);
  for i := 1 to StZnakov do Write('#');
  for i := StZnakov + 1 to SirinaVrat do Write(' ');
  Write('| ', VrataX:4:1, ' ');
  { Tale zadnja tevilka pove, kako dolgo so vrata e v trenutnem poloaju. }
  Write(' (', ((Cas - CasVrat) / 1000.0):5:1, ')');
  Write(#13);
end; {PrikaziStanje}

function NajKoncam: boolean;
const DeltaT = 10; { ms }
var c: char; VrataPrej: real; 
begin

  { Simulirajmo majhen asovni interval. }
  Delay(DeltaT); Cas := Cas + DeltaT;
  Budilka := Budilka - DeltaT;
  if Budilka < 0 then Budilka := 0;
  VrataPrej := VrataX;
  if UkazMotorja = Odpiraj then VrataX := VrataX + (0.001 * DeltaT) * HitrostVrat
  else if UkazMotorja = Zapiraj then VrataX := VrataX - (0.001 * DeltaT) * HitrostVrat;
  if VrataX > SirinaVrat then VrataX := SirinaVrat;
  if VrataX < 0 then VrataX := 0;
  if (VrataPrej <> VrataX) then CasVrat := Cas;

  PrikaziStanje;

  { Poglejmo, e je uporabnik pritisnil na kakno tipko. }
  NajKoncam := false;
  while KeyPressed do begin
    c := UpCase(ReadKey); if c = #0 then c := ReadKey;
    case c of
      'Q', 'X': begin NajKoncam := true; break; end;
      'P', '1': TipPesec := not TipPesec; 
      'A', '2': TipAvto := not TipAvto; 
      'V', '3': TipVstop := not TipVstop;
      'O', '4': TipOvira := not TipOvira;
      else begin
        Write('(pavza)', #13);
        c := UpCase(ReadKey); if c = #0 then c := ReadKey;
      end; {else}
    end; {case}
    PrikaziStanje;
  end; {while}
end; {NajKoncam}

begin {SimulatorVrat}
  WriteLn('Simulator vrat');
  WriteLn('S tipkami lahko spreminja stanje tipal:');
  WriteLn('(p)eec, (a)vto, (v)stop, (o)vira (ali 1, 2, 3, 4).');
  WriteLn('Q, X = izhod iz programa.  Ostale tipke = pavza.');
  WriteLn;
  
  Cas := 0; Budilka := 0; UkazMotorja := Stoj;
  CasVrat := 0; VrataX := 0.0; { vrata so zaprta }
  TipPesec := false; TipAvto := false; 
  TipOvira := false; TipVstop := false;
  
  Vrata;
end. {SimulatorVrat}
