program UnijaPravokotnikov(Input, Output); { RTK 1995.1.3 }

type Tocka = record x, y: real; end;
     Pravokotnik = record a, b: Tocka; end; 

function Max(a, b: real): real; 
  begin if a > b then Max := a else Max := b; end;

function Min(a, b: real): real; 
  begin if a < b then Min := a else Min := b; end;

procedure Zamenjaj(var a, b: real); 
var tmp: real; 
begin
  tmp := a; a := b; b := tmp; 
end; {Zamenjaj}

procedure Uredi(var a, b: Tocka); 
begin
  if a.x > b.x then Zamenjaj(a.x, b.x); 
  if a.y > b.y then Zamenjaj(a.y, b.y); 
end; {Uredi}

function Presek(var pa, pb: Pravokotnik): real; 
var PresekP: Pravokotnik; 
begin
  Uredi(pa.a, pa.b); 
  Uredi(pb.a, pb.b); 
  PresekP.a.x := Max(pa.a.x, pb.a.x); 
  PresekP.a.y := Max(pa.a.y, pb.a.y); 
  PresekP.b.x := Min(pa.b.x, pb.b.x); 
  PresekP.b.y := Min(pa.b.y, pb.b.y); 
  Presek := {\tabset}Max(PresekP.b.x - PresekP.a.x, 0) * 
    Max(PresekP.b.y - PresekP.a.y, 0); 
end; {Presek} 

function Unija(var pa, pb: Pravokotnik): real; 
begin
  Unija :=   (pa.b.x - pa.a.x) * (pa.b.y - pa.a.y) 
           + (pb.b.x - pb.a.x) * (pb.b.y - pb.a.y) 
           - Presek(pa, pb); 
end; {Unija} 

var a, b: Pravokotnik; 
begin {UnijaPravokotnikov}
  Write('1. pravokotnik, toka A: '); ReadLn(a.a.x, a.a.y); 
  Write('1. pravokotnik, toka B: '); ReadLn(a.b.x, a.b.y); 
  Write('2. pravokotnik, toka A: '); ReadLn(b.a.x, b.a.y); 
  Write('2. pravokotnik, toka B: '); ReadLn(b.b.x, b.b.y); 
  WriteLn('Presek = ', Presek(a, b):0:3); 
  WriteLn('Unija = ', Unija(a, b):0:3); 
end. {UnijaPravokotnikov}
