program PripraviIndeks; { RTK 1996.Z }
{ Ta program prebere datoteko s karticami (kNNN.txt)
  in pripravi indeksno datoteko (kNNN.idx), v kateri
  je za vsako tevilko (od 1 do 100) napisano, na
  katerih karticah se pojavlja.  Skratka, namesto po
  karticah je vsebina zdaj grupirana po tevilkah. }
type 
  { V tabeli tipa T1000Words bo element 0 hranil tevilo kartic 
    (iz neke skupine 1000 kartic), na katerih je neka tevilka,  
    naslednjih toliko elementov pa vsebuje indekse teh kartic. }
  P1000Words = ^T1000Words; 
  T1000Words = packed array[0..1000] of word; 
var 
  fIn: text; 
  fOut: file; 
  Buf: array[0..16383] of byte; { za hitreje branje datoteke s karticami } 
  Kartice: array[1..100] of P1000Words; { kartice trenutne skupine } 
  i, j, k, N, StSkupin: integer; 
begin
  if      ParamStr(1) = '1000'   then StSkupin := 1 
  else if ParamStr(1) = '10000'  then StSkupin := 10 
  else if ParamStr(1) = '100000' then StSkupin := 100 
  else    Halt; 
  Assign(fIn, 'k' + ParamStr(1) + '.txt'); 
  Reset(fIn); SetTextBuf(fIn, Buf, SizeOf(Buf)); 
  Assign(fOut, 'k' + ParamStr(1) + '.idx'); 
  Rewrite(fOut, 1); 
  for i := 1 to 100 do New(Kartice[i]); 
  for i := 0 to StSkupin - 1 do begin 
    { Obdelajmo naslednjih tiso kartic. } 
    for j := 1 to 100 do Kartice[j]^[0] := 0; 
    for j := 0 to 999 do begin 
      for k := 1 to 15 do begin 
        Read(fIn, N); 
        Inc(Kartice[N]^[0]); 
        Kartice[N]^[Kartice[N]^[0]] := j; 
      end;; 
      ReadLn(fIn); 
    end; {for j} 
    { Shranimo podatke o teh tiso karticah. } 
    for j := 1 to 100 do BlockWrite(fOut, 
      Kartice[j]^, SizeOf(word) * (Kartice[j]^[0] + 1)); 
  end; {for i} 
  Close(fIn); Close(fOut); 
  for i := 1 to 100 do Dispose(Kartice[i]); 
end. {PripraviIndeks} 
