program Steganografija; { RTK 1997.2.2 }
const w = 256; h = 256; 
const MaxDolzBesedila = (w div 8) * h;
var Slika: packed array[1..h, 1..w] of 0..255; 
    Besedilo: packed array[1..MaxDolzBesedila] of byte;
    DolzBes: integer;

procedure SkrijBesedilo; 
var 
  bi, iw, ih, j, ic, bit: integer; 
begin
  iw := 1; ih := 1; bi := 1;
  while ih <= h do begin 
    if bi > DolzBes then ic := 0
    else begin ic := Besedilo[bi]; Inc(bi); end;
    { Shrani 8 bitov znaka v zaporedne piksle, zani z najnijim bitom (lsb). } 
    { Predpostavimo, da je irina slike mnogokratnik 8. } 
    for j := 1 to 8 do begin 
      bit := ic mod 2; ic := ic div 2; { Izlui naslednji bit znaka. } 
      Slika[ih, iw] := (Slika[ih, iw] div 2) * 2 + bit; 
      iw := iw + 1; 
    end; {for}
    if iw > w then begin iw := 1; ih := ih + 1; end;
  end; {while}
end; {SkrijBesedilo} 

procedure RazkrijBesedilo; 
var 
  ic, i, j: integer; 
  k, kp: integer; { k teje bite; kp = 2^k } 
begin
  k := 0; kp := 1; ic := 0; DolzBes := 0;
  for i := 1 to h do 
    for j := 1 to w do begin 
      { Izlui zaporedne bite iz pikslov in jih zdrui po 8 v en znak. } 
      { Pazimo na obratni vrstni red bitov: najniji bit je v prvem pikslu. } 
      ic := ic + kp * (Slika[i, j] mod 2); k := k + 1; kp := 2 * kp; 
      if k >= 8 then begin{ Znak je kompleten. } 
        Inc(DolzBes); Besedilo[DolzBes] := ic;
        k := 0; kp := 1; ic := 0; { Pripravi se na nov znak. } 
      end; {if}
    end; {for}
  while DolzBes > 0 do if Besedilo[DolzBes] = 0 then Dec(DolzBes) else break;
end; {RazkrijBesedilo} 

procedure Pomoc;
begin
  WriteLn('rtk97s2n2 s slika.dat besedilo.txt -- skrije besedilo v sliko');
  WriteLn('  (e je besedilo prekratko, ga podalja z znaki #0.)');
  WriteLn('rtk97s2n2 r slika.dat besedilo.txt -- razkrije besedilo s slike');
  WriteLn('  (e so na koncu besedila znaki #0, jih poree.)');
  WriteLn('rtk97s2n2 n slika.dat -- zgenerira nakljuno sliko');
  Halt;
end; {Pomoc}

procedure PreberiSliko(ImeDatoteke: string);
var f: file;
begin
  WriteLn('Berem sliko iz ', ImeDatoteke, '.');
  Assign(f, ImeDatoteke); Reset(f, 1);
  BlockRead(f, Slika, SizeOf(Slika)); Close(f);
end; {PreberiSliko}

procedure ShraniSliko(ImeDatoteke: string);
var f: file;
begin
  WriteLn('Shranjujem sliko v ', ImeDatoteke, '.');
  Assign(f, ImeDatoteke); Rewrite(f, 1);
  BlockWrite(f, Slika, SizeOf(Slika)); Close(f);
end; {ShraniSliko}

var f: file; x, y: integer;
begin {Steganografija}
  if ParamCount < 2 then Pomoc;
  case UpCase(ParamStr(1)[1]) of
  
  'S': 
    begin
      if ParamCount < 3 then Pomoc;
      WriteLn('Berem besedilo iz ', ParamStr(3), '.');
      Assign(f, ParamStr(3)); Reset(f, 1);
      BlockRead(f, Besedilo, MaxDolzBesedila, DolzBes);
      Close(f);
      PreberiSliko(ParamStr(2));
      SkrijBesedilo;
      ShraniSliko(ParamStr(2));
    end;
  
  'R': 
    begin
      if ParamCount < 3 then Pomoc;
      PreberiSliko(ParamStr(2));
      RazkrijBesedilo;
      WriteLn('Shranjujem besedilo v ', ParamStr(3), '.');
      Assign(f, ParamStr(3)); Rewrite(f, 1);
      BlockWrite(f, Besedilo, DolzBes);
      Close(f);
    end; 
  
  'N': 
    begin
      for y := 1 to h do for x := 1 to w do
        Slika[y, x] := Random(256);
      ShraniSliko(ParamStr(2));
    end;
  
  end; {case}
end. {Steganografija}
