program StetjePodnizov; { RTK 1997.2.3 }
const MaxDolzNiza = 100; MaxDolzPodniza = 100;

{ Naivna reitev, z rekurzijo. }
function PrestejPodnize1(p, s: string): longint; 
var m, n: integer; 

  { Izrauna, kolikokrat se pojavi p[i..m] v nizu s[j..n]. } 
  function f(i, j: integer): integer; 
  begin
    if i > j then f := 0
    else if i = 0 then f := 1
    else if s[j] = p[i] then f := f(i, j - 1) + f(i - 1, j - 1)
    else f := f(i, j - 1); 
  end; {f} 

begin
  m := Length(p); n := Length(s); 
  PrestejPodnize1 := f(m, n); 
end; {PrestejPodnize1} 

{ Rekurzija + memoizacija. }
function PrestejPodnize2(p, s: string): longint; 
var m, n: integer; t: array[1..MaxDolzPodniza, 1..MaxDolzNiza] of integer; 

  function f(i, j: integer): integer; 
  begin
    if i > j then f := 0 
    else if i = 0 then f := 1
    else begin 
      if t[i, j] < 0 then 
        if s[j] = p[i] then t[i, j] := f(i, j - 1) + f(i - 1, j - 1)
        else t[i, j] := f(i, j - 1); 
      f := t[i, j];  
    end; {if}
  end; {f} 

var i, j: integer; 
begin
  m := Length(p); n := Length(s); 
  for i := 1 to m do for j := 1 to n do t[i, j] := -1; 
  PrestejPodnize2 := f(m, n); 
end; {PrestejPodnize2} 

{ Dinamino programiranje. }
function PrestejPodnize3(p, s: string): longint; 
var m, n, i, j, iMax: integer; 
    t: array[0..MaxDolzPodniza + 1] of integer; 
begin
  m := Length(p); n := Length(s); 
  { Izraunajmo najprej f(i, 1) za vse i.  
    Tu gledamo le prvi znak niza s in f(i, 1) je 0 za vse i > 1. }
  t[0] := 1; { Ker smo videli, da je koristno vzeti f(0, j) = 1. }
  for i := 1 to m do t[i] := 0;
  if p[1] = s[1] then t[1] := 1;
  { Izraunajmo zdaj f(i, j) za vse veje j. }
  for j := 2 to n do begin
    if j > m then iMax := m else iMax := j;
    for i := iMax downto 1 do 
      { V celicah t[i+1..m] so vrednosti f(i+1, j), ..., f(m, j),
        v celicah t[1..i] pa vrednosti f(1, j-1), ..., f(i, j-1).
        Izraunajmo f(i, j) in jo vpiimo v t[i]. }
      if p[i] = s[j] 
      then t[i] := t[i] + t[i - 1]   { f(i, j) = f(i, j-1) + f(i-1, j-1) }
      {else t[i] := t[i]};           { f(i, j) = f(i, j-1) }
  end; {for j}
  PrestejPodnize3 := t[m]; { f(m, n) }
end; {PrestejPodnize3}

function PrestejPodnize4(p, s: string): longint;
var m, n, i, j, iu, ju: integer;
    t: array [0..MaxDolzPodniza] of integer;
    su, iuZadnji: array [1..MaxDolzNiza] of integer;
    pu: array [1..MaxDolzPodniza] of integer;
begin
  m := Length(p); n := Length(s);
  for ju := 1 to n do su[ju] := ju;
  for iu := 1 to m do pu[iu] := iu;
  { Uredimo tabeli su in pu kar z navadnim urejanjem z 
    zamenjavami.   Pri daljih nizih bi bilo verjetno 
    bolje uporabiti kak hitreji algoritem. }
  for i := 1 to n - 1 do begin
    j := i; 
    for ju := i + 1 to n do 
      if (s[su[ju]] < s[su[j]]) 
      or ((s[su[ju]] = s[su[j]]) and (su[ju] < su[j])) then j := ju;
    iu := su[i]; su[i] := su[j]; su[j] := iu; 
  end; {for i}
  for i := 1 to m - 1 do begin
    j := i;
    for ju := i + 1 to m do 
      if (p[pu[ju]] < p[pu[j]]) 
      or ((p[pu[ju]] = p[pu[j]]) and (pu[ju] < pu[j])) then j := ju;
    iu := pu[i]; pu[i] := pu[j]; pu[j] := iu; 
  end; {for i}
  { Zdaj so v tabeli su indeksi od 1 do n urejeni po naraajoi
    vrednosti s[i], pri enakih s[i] pa po naraajoih i.
    Podobno velja za tabelo pu in niz p. }
  { Pripravimo za vsak j v tabeli iuZadnji[j] indeks iu 
    zadnjega elementa v tabeli pu, ki se e nanaa na 
    znak s[j], torej da je p[pu[iu]] = s[j] in je obenem
    tudi pu[iu] najveji moni. }
  iu := 0;
  for ju := 1 to n do begin
    j := su[ju];
    while iu < m do begin
      i := pu[iu + 1];
      if (p[i] > s[j]) or ((p[i] = s[j]) and (i > j)) then break;
      iu := iu + 1;
    end; {while}
    iuZadnji[j] := iu;
  end; {for ju}
  
  { Izraunajmo vrednosti f(i, 1) tako kot pri prejnji reitvi. }
  t[0] := 1;
  for i := 1 to m do t[i] := 0;
  if p[1] = s[1] then t[1] := 1;
  { Izraunajmo f(i, j) za veje j. }
  for j := 2 to n do begin 
    iu := iuZadnji[j];
    { pu[iu] je najveji tak indeks i, pri katerem je s[i] = p[j].
      Prejnje take indekse bomo nali v pu[iu-1], pu[iu-2] itd. }
    while iu > 0 do begin
      i := pu[iu]; if p[i] <> s[j] then break;
      t[i] := t[i] + t[i - 1];
      iu := iu - 1;
    end; {while}
  end; {for j}
  
  PrestejPodnize4 := t[m];
end; {PrestejPodnize4}

var Alg, i: integer; p, s: string;
begin {StetjePodnizov}
  if ParamCount < 3 then begin
    WriteLn('rtk1997s2n3 podniz niz algoritem');
    WriteLn('algoritem = 1 (rekurzija), 2 (memoizacija), ');
    WriteLn('  3 (dinamino programiranje), 4 (izboljava 3)');
    exit;
  end; {if}
  Val(ParamStr(3), Alg, i);
  if (i > 0) or (Alg < 1) or (Alg > 4) then Alg := 0;
  p := ParamStr(1); s := ParamStr(2);
  Write('PrestejPodnize', Alg, '("', p, '", "', S, '") = ');
  case Alg of
  1: WriteLn(PrestejPodnize1(p, s));
  2: WriteLn(PrestejPodnize2(p, s));
  3: WriteLn(PrestejPodnize3(p, s));
  4: WriteLn(PrestejPodnize4(p, s));
  else WriteLn(PrestejPodnize1(p, s), ' ', PrestejPodnize2(p, s), ' ', PrestejPodnize3(p, s), ' ', PrestejPodnize4(p, s)); 
  end; {case}
end. {StetjePodnizov}
