program SkupineMest; 

const 
  MaxM = 30000;   { Najveje mono tevilo mest. } 
  MaxN = 30000;   { Najveje mono tevilo neposrednih povezav. } 
  { Besedilo naloge pravi, da imajo mesta tevilke od 1 do m.
    Nekaj testnih primerov pa ima v resnici tudi mesto 0.
    e hoemo, da bo program pravilno deloval tudi na njih,
    postavimo MinSt na 0, sicer pa na 1. }
  MinSt = 0;

type 
  SosedjeT = array[0..MaxN - 1] of integer; 
  PSosedjeT = ^SosedjeT; 
  StSosedovT = array[MinSt..MaxM] of word; 
  ObiskaniT = array[MinSt..MaxM] of boolean; 

var 
  { i-ta neposredna povezava povezuje mesti PovOd^[i] in PovDo^[i]. } 
  PovOd, PovDo: PSosedjeT; 
  { Sklad in tabelo Obiskani uporabljamo med preiskovanjem omreja. } 
  Sklad: PSosedjeT; Obiskani: ^ObiskaniT; 
  { Pri n neposrednih povezavah je lahko skupna dolina vseh seznamov sosedov  
    do 2 * n.  Tolikna tabela ne bi la v en 64-KB segment, zato jo razbijmo na 
    dva kosa.  Element x zapiimo v Sosedje[x mod 2]^[x div 2].  Sosedje mesta i
    so na indeksih od PrviSosed^[i] do PrviSosed^[i] + StSosedov^[i] - 1. }
  Sosedje: array[0..1] of PSosedjeT; 
  StSosedov, PrviSosed: ^StSosedovT; 
  f: text; n, m, i, u, v, SP, StSkupin: integer; j: word; 

begin

  { Preberimo podatke o cestnem omreju. } 
  New(Sosedje[0]); New(Sosedje[1]);  
  New(PovOd); New(PovDo); New(StSosedov); New(PrviSosed); 
  if ParamCount >= 1 then Assign(f, ParamStr(1))
  else Assign(f, 'input.txt'); 
  Reset(f); ReadLn(f, m); ReadLn(f, n); 
  for i := MinSt to m do StSosedov^[i] := 0; 
  for i := 1 to n do begin 
    ReadLn(f, u, v); PovOd^[i] := u; PovDo^[i] := v; 
    Inc(StSosedov^[u]); Inc(StSosedov^[v]); 
  end; {for}
  Close(f); 

  { Zdaj za vsako mesto vemo, s kolikimi je neposredno povezano. 
    Pripravimo sezname sosedov za vsako mesto. }
  PrviSosed^[MinSt] := 1; 
  for i := MinSt to m - 1 do PrviSosed^[i + 1] := PrviSosed^[i] + StSosedov^[i]; 
  for i := MinSt to m do StSosedov^[i] := 0; 
  for i := 1 to n do begin 
    u := PovOd^[i]; v := PovDo^[i]; 
    { Dodajmo v med u-jeve sosede in u med v-jeve.  Lahko je u = v in  
      zato moramo StSosedov^[u] poveati, e preden uporabimo StSosedov^[v]. 
      No, lahko bi tudi e med branjem vhodne datoteke preskoili vse povezave 
      od u do u in na koncu branja primerno zmanjali n. }
    j := PrviSosed^[u] + StSosedov^[u]; Inc(StSosedov^[u]);  
    Sosedje[j mod 2]^[j div 2] := v;  
    j := PrviSosed^[v] + StSosedov^[v]; Inc(StSosedov^[v]); 
    Sosedje[j mod 2]^[j div 2] := u; 
  end; {for}
  Dispose(PovOd); Dispose(PovDo); New(Sklad); New(Obiskani); 

  { Zdaj lahko poiemo in pretejemo skupine povezanih mest. } 
  StSkupin := 0; for i := MinSt to m do Obiskani^[i] := false; 
  for i := MinSt to m do if not Obiskani^[i] then begin
    { Preglejmo vsa mesta, povezana z i.  Na skladu si bomo zapomnili, 
      kaj moramo e pregledati.  SP je tevilo mest na skladu. }
    Inc(StSkupin); SP := 1; Sklad^[SP] := i; Obiskani^[i] := true; 
    while SP > 0 do begin 
      u := Sklad^[SP]; Dec(SP); 

      { Obiimo zdaj vse u-jeve sosede, e jih nismo obiskali e kdaj prej. } 
      for j := PrviSosed^[u] to PrviSosed^[u] + StSosedov^[u] - 1 do begin 
        v := Sosedje[j mod 2]^[j div 2];  
        if not Obiskani^[v] then 
          begin Inc(SP); Sklad^[SP] := v; Obiskani^[v] := true; end; 
      end; {for j} 

    end; {while}
  end; {for i} 

  { Nekateri testni primeri imajo mesta 0..m, nekateri pa 1..m.
    e imamo MinSt = 0, si vedno mislimo tudi mesto 0..m; e
    ima testni primer le mesta 1..m, smo nateli eno skupino
    preve (tisto, v kateri je le mesto 0). }
  if MinSt = 0 then if StSosedov^[0] = 0 then Dec(StSkupin);

  { Izpiimo rezultate, poistimo pomnilnik. } 
  if ParamCount >= 2 then Assign(f, ParamStr(2))
  else Assign(f, 'output.txt'); 
  Rewrite(F); WriteLn(f, StSkupin); Close(f); 
  Dispose(Sosedje[0]); Dispose(Sosedje[1]); Dispose(StSosedov);  
  Dispose(PrviSosed); Dispose(Sklad); Dispose(Obiskani); 

end. {SkupineMest} 
  