program Rozine2; { RTK 1997.Z.2 }
{ Toke iz soseine ne pregleduje z dvema vgnezdenima
  zankama (kot Rozine1), pa pa z dvema prepletenima.
  Vendar pa mora v ta namen toke prej urediti po 
  naraajoih Y.  Algoritem urejanja lahko izbiramo
  s tretjim parametrom na ukazni vrstici ('S', 'I' ali 'Q').
  S etrtim parametrom pa lahko izberemo razliico
  programa za iskanje tok v soseini ('1' oz. '2'
  za FindNeigh1 oz. FindNeigh2). }

const MaxN = 10000; 
type 
  TabelaI = array[1..MaxN] of integer; 
  TabelaR = array[1..MaxN] of real; 
var
  PtX, PtY: ^TabelaR;  { koordinate tok } 
  N: integer;          { tevilo tok } 
  A, B: real;          { velikost poizvedovalnega okna } 
  
  procedure SelectionSort;  { Uredi toke po naraajoih Y-koordinatah. } 
  var i, j, k: integer; Y0, Y1, T: real; 
  begin
    for i := 1 to N do begin 
      { Naj bo k najnija toka izmed tok i..n. } 
      Y0 := PtY^[i]; k := i;  
      for j := i + 1 to N do begin 
        Y1 := PtY^[j]; if Y1 >= Y0 then continue; 
        Y0 := Y1; k := j; 
      end; {for j} 
      { Zamenjajmo k s toko i. } 
      T := PtX^[i]; PtX^[i] := PtX^[k]; PtX^[k] := T;  
      T := PtY^[i]; PtY^[i] := PtY^[k]; PtY^[k] := T;  
    end; {for i} 
  end; {SelectionSort} 
  
  procedure InsertionSort;  { Uredi toke po naraajoih Y-koordinatah. } 
  var i, j: integer; X0, Y0: real; 
  begin
    for i := 2 to N do begin 
      { Zaporedje tok 1..i - 1 je e urejeno.  Vstavimo vanj toko i. } 
      j := i - 1; X0 := PtX^[i]; Y0 := PtY^[i]; 
      while j > 0 do begin 
        if PtY^[j] <= Y0 then break; 
        PtX^[j + 1] := PtX^[j]; PtY^[j + 1] := PtY^[j]; Dec(j); 
      end; {while}
      PtX^[j + 1] := X0; PtY^[j + 1] := Y0; 
    end; {for}
  end; {InsertionSort} 
  
  procedure QuickSort(L, R: integer); { Uredi toke L..R po naraajoih Y. } 
  var i, j: integer; T, M: real; 
  begin
    while L < R do begin 
      M := PtY^[(L + R) div 2]; i := L; j := R; 
      { Razdelimo toke na tiste pod in tiste nad Y = M. } 
      while i < j do begin 
        { Invarianta: toke L..i imajo Y $<=$ M, toke j..R pa Y $>=$ M. } 
        while PtY^[i] < M do Inc(i); 
        while PtY^[j] > M do Dec(j); 
        if i <= j then begin
          T := PtX^[i]; PtX^[i] := PtX^[j]; PtX^[j] := T;  
          T := PtY^[i]; PtY^[i] := PtY^[j]; PtY^[j] := T;  
          Inc(i); Dec(j); 
        end; {if}
      end; {while}
      { Toke L..j imajo Y <= M, toke i..R pa Y >= M. 
        Manjo od teh dveh skupin uredimo z rekurzivnim klicem, veje pa 
        se bomo lotili v naslednji ponovitvi zunanje zanke while. }
      if j - L < R - i then begin QuickSort(L, j); L := i; end
      else begin QuickSort(i, R); R := J; end; 
    end; {while}
  end; {QuickSort} 
  
  { Spodnja razliica ne ureja le po Y, pa pa 
    (e ima ve tok enak Y), tudi po X. 
    To se izkae za koristno pri enem od patolokih testnih primerov,
    e namesto FindNeigh2 uporabljamo FindNeigh1. }
  procedure QuickSort2(L, R: integer); { Uredi toke L..R po naraajoih Y. } 
  var i, j: integer; T, M, MX: real; 
  begin
    while L < R do begin 
      M := PtY^[(L + R) div 2]; MX := PtX^[(L + R) div 2]; i := L; j := R; 
      { Razdelimo toke na tiste pod in tiste nad Y = M. } 
      while i < j do begin 
        { Invarianta: toke L..i imajo Y $<=$ M, toke j..R pa Y $>=$ M. } 
        while (PtY^[i] < M) or ((PtY^[i] = M) and (PtX^[i] < MX)) do Inc(i); 
        while (PtY^[j] > M) or ((PtY^[j] = M) and (PtX^[j] > MX)) do Dec(j); 
        if i <= j then begin
          T := PtX^[i]; PtX^[i] := PtX^[j]; PtX^[j] := T;  
          T := PtY^[i]; PtY^[i] := PtY^[j]; PtY^[j] := T;  
          Inc(i); Dec(j); 
        end; {if}
      end; {while}
      { Toke L..j imajo Y <= M, toke i..R pa Y >= M. 
        Manjo od teh dveh skupin uredimo z rekurzivnim klicem, veje pa 
        se bomo lotili v naslednji ponovitvi zunanje zanke while. }
      if j - L < R - i then begin QuickSort2(L, j); L := i; end
      else begin QuickSort2(i, R); R := J; end; 
    end; {while}
  end; {QuickSort} 
  
  procedure QuickSortW; begin QuickSort(1, N); end;
  procedure QuickSort2W; begin QuickSort2(1, N); end;

var Neigh: ^TabelaI; nNeigh: integer; { toke v okolici trenutne toke } 

  { V Neigh vpie toke z X0 <= X <= X0 + A, Y0 - B <= Y <= Y0 + B. 
    Uporabi navadno linearno iskanje -- gre po vseh tokah in
    za vsako posebej preveri, e ustreza pogojem. } 
  procedure FindNeigh1(X0, Y0: real); 
  var i: integer;  
  begin
    nNeigh := 0; 
    for i := 1 to N do 
      if   (X0 <= PtX^[i])     and (PtX^[i] <= X0 + A) 
      and  (Y0 - B <= PtY^[i]) and (PtY^[i] <= Y0 + B) 
      then begin Inc(nNeigh); Neigh^[nNeigh] := I; end;
  end; {FindNeigh1} 

  { Ker so toke e urejene po Y, lahko z bisekcijo hitro poiemo
    najnijo toko z Y0 - B <= Y, nato pa gremo od tam naprej po
    naraajoih Y (dokler ne postane Y > Y0 + B) in toke, ki
    ustrezajo tudi pogoju X0 <= X <= A, dodajamo v seznam Neigh. }
  procedure FindNeigh2(X0, Y0: real); 
  var i, L, R: integer; 
  begin
    { Bisekcija. } 
    L := 1; R := N + 1; 
    while L + 1 < R do begin 
      { Invarianta: L = 1 ali pa PtY^[L] <= Y0 - B < PtY^[R]. } 
      i := (L + R) div 2; 
      if PtY^[I] <= Y0 - B then L := i else R := i; 
    end; {while}
    { Toke z Y >= Y0 + B se nahajajo na indeksih od L naprej. } 
    nNeigh := 0; 
    while L <= N do begin 
      if PtY^[L] > Y0 + B then break; 
      if (X0 <= PtX^[L]) and (PtX^[L] <= X0 + A) then 
        begin Inc(nNeigh); Neigh^[nNeigh] := L; end;
      Inc(L); 
    end; {while}
  end; {FindNeigh2} 

type 
  SortT = procedure;
  FindNeighT = procedure(X0, Y0: real);
var 
  i, j, k, Best: integer; F: text; Y1: real; 
  Sort: SortT; FindNeigh: FindNeighT;
begin {Rozine2} 

  { Preberimo vhodne podatke. } 
  New(PtX); New(PtY); 
  if ParamCount >= 1 then Assign(F, ParamStr(1))
  else Assign(F, 'input.txt'); 
  Reset(F); ReadLn(F, A, B); ReadLn(F, N); 
  for i := 1 to N do ReadLn(F, PtX^[i], PtY^[i]);  
  Close(F); 
  
  Sort := @QuickSortW;
  if ParamCount >= 3 then case UpCase(ParamStr(3)[1]) of
    'I': Sort := @InsertionSort;
    'S': Sort := @SelectionSort;
    'R': Sort := @QuickSort2W;
  end; {case}
  FindNeigh := @FindNeigh2;
  if ParamCount >= 4 then case UpCase(ParamStr(4)[1]) of
    '1': FindNeigh := @FindNeigh1;
  end; {case}

  { Uredimo toke po naraajoih Y-koordinatah. } 
  Sort;

  { Pojdimo po vseh tokah. } 
  Best := 0; New(Neigh);  
  for i := 1 to N do begin 
    
    { Preglejmo pravokotnike, ki imajo toko i na levi stranici.  
      V Neigh pripravimo vse toke, ki bi utegnile biti v kaknem 
      takem pravokotniku. }
    FindNeigh(PtX^[i], PtY^[i]); 
    
    { Poskusimo vse mone poloaje spodnje stranice pravokotnika. } 
    k := 2; 
    for j := 1 to nNeigh do begin 
      Y1 := PtY^[Neigh^[j]]; 
      { Pravokotnik s spodnjo stranico pri Y1 pokriva toke Neigh^[j..k - 1]. } 
      while k <= nNeigh do 
        if PtY^[Neigh^[k]] > Y1 + B then break else Inc(k); 
      if k - j > Best then Best := k - j; 
    end; {for j} 
  end; {for i} 
  
  { Izpiimo rezultat in poistimo pomnilnik. } 
  if ParamCount >= 2 then Assign(F, ParamStr(2))
  else Assign(F, 'output.txt'); 
  Rewrite(F); WriteLn(F, Best); Close(F); 
  Dispose(Neigh); Dispose(PtX); Dispose(PtY); 
end. {Rozine2} 
