program RacunanjeSStevkami; { RTK 1999.2.1 }

  { Izvede S[d] := S[i1] Op S[i2]. }
  procedure Op(var S: string; O: char; d, s1, s2: integer);
  var o1, o2, r, i: integer;
  begin
    { Napiimo, kaj bomo naredili. }
    WriteLn(S);
    for i := 1 to Length(S) do 
      if (i = d) and ((i = s1) or (i = s2)) then Write('|')
      else if (i = d) then Write('v')
      else if (i = s1) or (i = s2) then Write('^') 
      else Write(' ');
    WriteLn(' ', O);
    { Izvedimo operacijo. }
    o1 := Ord(S[s1]) - Ord('0'); o2 := Ord(S[s2]) - Ord('0');
    case O of 
      '+': r := (o1 + o2) mod 10; 
      '-': r := (o1 - o2 + 10) mod 10; 
      '/': r := o1 div o2;
    end; {case}
    S[d] := Chr(r + Ord('0'));
  end; {Op}

  { Predpostavi, da velja S[i1] = 1 in S[i2] = 0.
    Poskrbi, da bo veljalo S[i1] = C1 in S[i2] = C2. }
  procedure DveStevki(var S: string; C1, C2: char; i1, i2: integer);
  begin
    { Trenutno je S[C1] = 1, S[C2] = 0. }
    if C1 = '0' then begin
      { S[i2] := C2 }
      while S[i2] < C2 do Op(S, '+', i2, i2, i1);
      while S[i2] > C2 do Op(S, '-', i2, i2, i1);
      Op(S, '-', i1, i1, i1); { S[c1] := 0 }
    end else if C2 = '0' then begin
      DveStevki(S, C2, C1, i1, i2); { S[i1] := 0, S[i2] := C1 }
      Op(S, '+', i1, i1, i2); { S[i1] := C1 }
      Op(S, '-', i2, i2, i2); { S[i2] := 0 }
    end else if C1 >= C2 then begin
      { S[i1] := C1 - C2, S[i2] := C2 }
      DveStevki(S, Chr(Ord('0') + Ord(C1) - Ord(C2)), C2, i1, i2);
      Op(S, '+', i1, i1, i2); { S[i1] := C1 }
    end else begin
      { S[i1] := C1, S[i2] := C2 - C1 }
      DveStevki(S, C1, Chr(Ord('0') + Ord(C2) - Ord(C1)), i1, i2);
      Op(S, '+', i2, i2, i1); { S[i2] := C2 }
    end; {if}
  end; {DveStevki}

  procedure DveStevili(S, Cilj: string);
  var i, i2, j, n: integer;
  begin
    WriteLn('Od ', S, ' do ', Cilj, ':');
    { Preverimo, e sta razlino dolgi ali pa sta e enaki. }
    if Length(S) <> Length(Cilj) then 
      begin WriteLn('tevili sta razlino dolgi.'); exit; end;
    if S = Cilj then
      begin WriteLn('tevili sta e zdaj enaki.'); exit; end;
  
    { Preverimo, e ni S iz samih niel. }    
    i := 1; n := Length(S);
    while i <= n do
      if S[i] = '0' then i := i + 1 else break;
    if i > n then 
      begin WriteLn('Iz ', S, ' se ne da dobiti ', Cilj, '.'); exit; end;
    
    { e imamo razlini enomestni tevili, se da iz poljubnega 
      nenielnega S dobiti tevila 0, 1, 2, 4, 8 in 6, drugih pa ne. }
    if n = 1 then begin
      if Cilj[1] in ['3', '5', '7', '9'] then 
        begin WriteLn('Iz ', S, ' se ne da dobiti ', Cilj, '.'); exit; end;
      { 0 lahko dobimo z odtevanjem. }
      if Cilj[1] = '0' then begin Op(S, '-', i, i, i); WriteLn(S); exit; end;
      { 1 lahko dobimo z deljenjem. }
      if Cilj[1] = '1' then Op(S, '/', i, i, i); { S[i] := 1 }
      { 2, 4, 8, 6 dobimo s podvajanjem. }
      while S[1] <> Cilj[1] do Op(S, '+', i, i, i); { S[i] := 2 * S[i] }
      WriteLn(S); exit; 
    end; {if}
    
    { tevka S[i] je razlina od 0.  Naj bo i2 e poljubno drugo mesto. }
    i2 := (i mod n) + 1;
    if S[i] <> '1' then Op(S, '/', i, i, i); { S[i] := 1 }
    for j := 1 to n do if (j <> i) and (j <> i2) then begin
      while S[j] < Cilj[j] do Op(S, '+', j, j, i); { S[j] := S[j] + 1 }
      while S[j] > Cilj[j] do Op(S, '-', j, j, i); { S[j] := S[j] + 1 }
    end; {for j}
    
    { Zdaj se S ujema s ciljnim tevilom povsod, 
      razen mogoe na mestih i in i1. }
    if (S[i] <> Cilj[i]) or (S[i2] <> Cilj[i2]) then begin
      if S[i2] <> '0' then Op(S, '-', i2, i2, i2);
      DveStevki(S, Cilj[i], Cilj[i2], i, i2);
    end; {if}
    
    WriteLn(S, ' = ', Cilj);
  end; {DveStevili}
  
var S: string; i: integer;
begin {RacunanjeSStevkami}
  if ParamCount >= 2 then 
    DveStevili(ParamStr(1), ParamStr(2))
  else while not Eof do begin
    ReadLn(S);
    i := 1; while i <= Length(S) do if S[i] = ' ' then break else i := i + 1;
    DveStevili(Copy(S, 1, i - 1), Copy(S, i + 1, Length(S) - i));
    WriteLn;
  end; {while, if}
end. {RacunanjeSStevkami}
