program ShranjevanjeMeritev; { RTK 1999.2.3 }
{$I+}
{ Programu lahko prek parametrov v ukazni vrstici povemo,
  ali naj shrani novo meritev ali izpie shranjene 
  vrednosti nekega tevca.  Pri shranjevanju meritev
  lahko simuliramo tudi napake (program med shranjevanjem
  klie Halt, da se takoj prekine).  Glej podprogram Navodila. }

uses Dos, Windows; { zaradi podprograma Izplakni }

const N = 10; M = 5;  {const N = 2000000; M = 1000;}
type StevciT = array[1..N] of integer;

{ Tale razliica podprograma Izplakni deluje s prevajalnikom
  FreePascal na Windowsih -- kje drugje bi bilo pa kako drugae.
  - Spremenljivke tipa file (ali file of Nekaj) so v resnici 
    primerki strukture FileRec, ki je deklarirana v enoti Dos.
  - FileRec.Handle je tevilka, ki jo lahko uporabimo za delo 
    s to datoteko pri klicih operacijskega sistema.  
  - Uporabili bomo standardno Win32 funkcijo FlushFileBuffers, 
    ki je deklarirana v enoti Windows. }
procedure Izplakni(var F);
begin
  FlushFileBuffers(FileRec(F).Handle);
end; {Izplakni}

procedure Shrani(var Stevci: StevciT; Cas, Nap, NapN: integer); 
var F: file of integer;  
    Prvi, Koliko, Kam, i: integer; 
begin
  { Izpiimo, kaj bomo poeli. }
  Write('Shrani(Cas = ', Cas, ', Stevci =');
  for i := 1 to N do Write(' ', Stevci[i]);
  WriteLn(')');
  
  { Odprimo datoteko, preberimo glavo in izraunajmo,
    kam bo treba zapisovati nove meritve. }
  Assign(F, 'shramba'); Reset(F);
  Read(F, Prvi, Koliko); 
  Kam := (Prvi + Koliko) mod (M + 1); 
  Seek(F, 2 + Kam * (N + 1)); 
  WriteLn('Prvi = ', Prvi, ', Koliko = ', Koliko, ', Kam = ', Kam);
  
  { Zapiimo as. }
  Write(F, Cas); 
  if Nap = 1 then begin WriteLn('Napaka po zapisu asa.'); Halt; end; 
  { Zapiimo vse meritve. }
  for i := 1 to N do begin
    Write(F, Stevci[i]); 
    if (Nap = 2) and (NapN = i) then begin WriteLn('Napaka po zapisu meritve ', i, '.'); Halt; end;
  end; {for}
  { Poskrbimo, da se ti podatki res shranijo na disk. }
  Izplakni(F); 
  if Nap = 3 then begin WriteLn('Napaka po zapisu vseh meritev.'); Halt; end;
  
  { Popravimo glavo.  e smo imeli e prej M blokov, jih bo zdaj e
    vedno M, le da se spremeni indeks prvega (tisti, ki je bil doslej
    prvi, postane neveljaven in ga bomo kasneje povozili. }
  if Koliko = M then begin 
    Prvi := (Prvi + 1) mod (M + 1); WriteLn('Prvi := ', Prvi);
    Seek(F, 0); Write(F, Prvi); 
    { Opomba: tale napaka pri Nap = 4 najbr ne more imeti nobenega 
      uinka ve.  Write je e poslal podatek (v tem primeru 
      vrednost Prvi) operacijskemu sistemu in tudi e mi program
      zdajle takoj prekinemo (Halt), bo OS pozaprl datoteke, ki jih
      ima program odprte, in pri tem poskrbel, da se bodo podatki,
      ki jih je e dobil, zapisali na disk.  Skratka, namesto klica
      Halt bi morali tule dejansko izpuliti kabel iz elektrike. :) }
    if Nap = 4 then begin WriteLn('Napaka po zapisu nove vrednosti Prvi.'); Halt; end;
  end 
  { e pa smo imeli prej manj kot M blokov, smo zdaj pa dodali
    nov blok.  Prvi blok se ne spremeni, povea pa se tevilo blokov. }
  else begin 
    { Pozor: videti je, da ima FreePascal nekaken bug v primerih,
      ko parameter pri klicu Write ni niti konstanta niti spremenljivka,
      ampak nek aritmetini izraz -- npr. pri Write(F, Koliko + 1).
      Zato bomo raje popravili spremenljivko Koliko in klicali le Write(F, Koliko). }
    Koliko := Koliko + 1; WriteLn('Koliko := ', Koliko);
    Seek(F, 1); Write(F, Koliko);
    if Nap = 4 then begin WriteLn('Napaka po zapisu nove vrednosti Koliko.'); Halt; end;
  end; {if}
  
  { Zaprimo datoteko. }
  Izplakni(F); 
  Close(F); 
end; {Shrani} 

procedure Izpisi(Stevec: integer); 
var F: file of integer; 
    OdKod, Koliko, T, X: integer; 
begin
  WriteLn('Shranjene meritve tevca ', Stevec, ':');
  Assign(F, 'shramba'); Reset(F); 
  Read(F, OdKod, Koliko); 
  WriteLn('(OdKod = ', OdKod, ', Koliko = ', Koliko, ')');
  while Koliko > 0 do begin 
    { Preberimo as te meritve. }
    Seek(F, 2 + OdKod * (N + 1)); 
    Read(F, T); 
    { Preberimo vrednost tevca. }
    Seek(F, 2 + OdKod * (N + 1) + Stevec); 
    Read(F, X); 
    WriteLn(T, ' ', X); 
    { Premik na naslednjo meritev. }
    Koliko := Koliko - 1; OdKod := (OdKod + 1) mod (M + 1); 
  end; {while}
  Close(F); 
end; {Izpisi} 

procedure Inicializacija; 
var F: file of integer; 
begin
  { Pripravimo prazno datoteko, v glavo zapiimo, da meritev e ni. }
  Assign(F, 'shramba'); Rewrite(F); 
  Write(F, 0, 0); Close(F); 
  WriteLn('Shramba pripravljena.');
end; {Inicializacija} 

procedure Navodila;
begin
  WriteLn('rtk99s2n3 s <cas> <x> [<nap> [<napN>]]');
  WriteLn('  Shrani <x>+i kot vrednost tevca i (za vsak i) in <cas> (celo');
  WriteLn('  tevilo) kot as, ko so bile pomerjene.  Z <nap> zahtevamo, ');
  WriteLn('  ali naj se dela, da je prilo do napake, in kdaj (1..4; ');
  WriteLn('  pri 2 je lahko prisotna e <napN> z intervala 1..', N, ').');
  WriteLn('rtk99s2n3 i <tevec>');
  WriteLn('  Izpie vse vrednosti danega tevca (tevci so 1..', N, ').');
  WriteLn('rtk99s2n3 n');
  WriteLn('  Inicializacija (pripravi prazno datoteko za shranjevanje meritev).');
  Halt;
end;

function StringToInt(S: string): integer;
var x, i: integer;
begin
  Val(S, x, i); 
  if i > 0 then 
    begin WriteLn('"', S, '" ni celo tevilo.'); Navodila; end;
  StringToInt := x;
end;

var i, Vrednost, Nap, NapN: integer;
    Stevci: StevciT;
begin {ShranjevanjeMeritev}

  if ParamCount < 1 then Navodila;
  case UpCase(ParamStr(1)[1]) of

  'S': begin
    if ParamCount < 3 then Navodila;
    Vrednost := StringToInt(ParamStr(3));
    for i := 1 to N do Stevci[i] := Vrednost + i;
    if ParamCount <= 3 then Nap := 0
    else begin
      Nap := StringToInt(ParamStr(4));
      if Nap = 2 then 
        if ParamCount >= 5 then NapN := StringToInt(ParamStr(5))
        else NapN := Random(N) + 1;
    end; {if}
    Shrani(Stevci, StringToInt(ParamStr(2)), Nap, NapN);
  end;

  'I': if ParamCount < 2 then Navodila
       else Izpisi(StringToInt(ParamStr(2)));

  'N': Inicializacija;

  else Navodila;
  end; {case}
end. {ShranjevanjeMeritev}
