program Ministri1; { RTK 1999.3.2 }
{ Reitev z rekurzijo. }

  const N = 11; { Najve ministrov } 

  function IzpisiKoalicije(Stevilo: integer): integer; 
  type Koal = set of 1..N; 
       Iter = record 
         Koliko: integer; 
         Koalicije: array[1..N] of Koal; 
       end; {Iter}
  var a: Iter; Stevec: longint; 
  
    { Izpie vsa taka razbitja ministrov na koalicije, ki jih je 
      mo dobiti, e v razbitje a dodamo vse ministre od 
      Naslednji do Stevilo. }
    procedure RekurzivnoIzpisi(var a: Iter; Naslednji: integer); 
    
      procedure Izpisi(a: Iter); { Izpie celo razbitje na koalicije. }
      
        procedure IzpisiEno(k: Koal); { Izpie eno koalicijo. }
        var i: integer; 
        begin
          for i := 1 to Stevilo do 
            if i in k then Write(Chr(i + Ord('A') - 1)); 
        end; {IzpisiEno} 
        
      var i: integer; 
      begin {Izpisi} 
        for i := 1 to a.Koliko do begin 
          if i > 1 then Write(','); 
          IzpisiEno(a.Koalicije[i]); 
        end; {for}
        WriteLn; Stevec := Stevec + 1; 
      end; {Izpisi} 
      
    var i: integer; 
    begin {RekurzivnoIzpisi} 
      a.Koalicije[a.Koliko + 1] := []; 
      for i := 1 to a.Koliko + 1 do begin 
        { Ministra Naslednji dodajmo v i-to koalicijo.
          e je i = a.Koliko + 1, pomeni, da bo ustanovil
          novo koalicijo, v kateri bo na zaetku samo on. 
          Mimogrede, na ustavitev zanke for ne bo to poveanje
          vrednosti a.Koliko ni vplivalo, saj zanka vrednosti
          a.Koliko + 1 ne rauna znova po vsaki ponovitvi, ampak
          le na zaetku (glej standard za pascal, razdelek 6.8.3.9). }
        a.Koalicije[i] := a.Koalicije[i] + [Naslednji]; 
        if i = a.Koliko + 1 then a.Koliko := a.Koliko + 1; 
        { Zdaj izvedimo rekurzivni klic za preostale ministre;
          e pa je Naslednji e zadnji, lahko razbitje izpiemo. }
        if Naslednji = Stevilo 
          then Izpisi(a) 
          else RekurzivnoIzpisi(a, Naslednji + 1); 
        { Odstranimo ministra Naslednji iz i-te koalicije,
          da bo naslednja iteracija te zanke lahko nadaljevala
          pri naslednji koaliciji. }
        a.Koalicije[i] := a.Koalicije[i] - [Naslednji]; 
      end; {for i}
      { V zadnji iteraciji nae zanke smo dodali eno novo koalicijo,
        zdaj pa jo pobriimo. }
      a.Koliko := a.Koliko - 1;
    end; {RekurzivnoIzpisi} 
    
  begin {IzpisiKoalicije} 
    Stevec := 0; a.Koliko := 0; 
    RekurzivnoIzpisi(a, 1); 
    IzpisiKoalicije := Stevec; 
  end; {IzpisiKoalicije} 
  
var Stevilo, StMin, i: integer; 
begin {Ministri1}
  if ParamCount >= 1 then begin
    Val(ParamStr(1), StMin, i); WriteLn('tevilo ministrov: ', StMin);
  end else begin
    Write('Vnesi tevilo ministrov (od 1 do ', N, '): '); 
    ReadLn(StMin); 
  end; {if}
  if (StMin < 1) or (StMin > N) then WriteLn('Od 1 do ', N, ', sem rekel!') 
  else begin
    Stevilo := IzpisiKoalicije(StMin); 
    WriteLn('Vseh monih koalicij je ', Stevilo, '.'); 
  end;; 
end. {Ministri1} 
