program Smucarji; { RTK 2003.3.2 }
const MaxM = 3000; MaxN = 3000; MaxT = 100000;
var 
  f: text; 
  s, ui, i, r, n, m, Najboljsa: Integer;
  t: array[0..MaxM] of LongInt; 
  a: array[1..MaxN + 1] of LongInt;
begin
  { Branje vhodnih podatkov. }
  if ParamCount >= 1 then Assign(f, ParamStr(1)) 
  else Assign(f, 'smucarji.in');
  Reset(f);
  { Na konec tabele a dajmo kot straarja enega isto brezupnega 
    smuarja, ki ne more prehiteti nikogar.  Na zaetek tabele t 
    dajmo kot straarja odlino uvrstitev, s katero nas lahko 
    prehiti vsakdo, celo tisti brezupni smuar. }
  ReadLn(f, m); t[0] := 2 * MaxT + 2; for i := 1 to m do ReadLn(f, t[i]);
  ReadLn(f, n); a[n + 1] := -MaxT - 1; for i := 1 to n do ReadLn(f, a[i]);
  Close(f); 
  
  if ParamCount >= 2 then Assign(f, ParamStr(2)) 
  else Assign(f, 'smucarji.out');
  Rewrite(f); Najboljsa := 1;
  
  for s := 1 to n do begin

    { Poiimo najbolji in najslabi moni konni poloaj s-tega smuarja. }
    while a[s] + t[1] < a[Najboljsa] do Inc(Najboljsa);

    { Katero mesto mora smuar s+1 dosei, da nas bo prehitel? }
    ui := 0; if n - s > m then r := m + 1 else r := n - s + 1;
    while ui + 1 < r do begin { Bisekcija. }
      { Invarianta: e dosee tekmovalec s+1 ui-to mesto,
        bo tekmovalca s v skupnem setevku prehitel, e
        dosee r-to mesto, pa ne. }
      i := (ui + r) div 2;
      if t[i] + a[s + 1] > a[s] then ui := i else r := i;
    end; {while}

    { Tekmovalec s+1 mora dosei ui-to ali bolje mesto.
      e nas prehiti k tekmovalcev, bo dosegel k-to. 
      Torej mora biti k <= ui. }
    i := 1; r := ui;
    while i <= r do begin
      { Invarianta: r = min(u_j + j - 1 : j = 1, ..., i). 
        Zaradi i <= r e vemo, da nas lahko prehiti i smuarjev. }
      i := i + 1; { Nas lahko prehiti i+1 smuarjev? }
      while ui > 0 do
        if t[ui] + a[s + i] <= a[s] then Dec(ui) else break;
      { Tekmovalec s+i potrebuje ui-to mesto, da nas bo prehitel. 
        e nas prehiti k tekmovalcev, bo dosegel (k+1-i)-to. 
        Torej mora biti k + 1 - i <= ui oz. k <= ui + i - 1. }
      if r > ui + i - 1 then r := ui + i - 1;
    end; {while i <= r}

    { Lahko nas prehiti i-1 smuarjev, ne pa tudi i smuarjev. }
    WriteLn(f, Najboljsa, ' ', s + i - 1);

  end; {for s}
  Close(f);
end. {Smucarji}
