program VpliviSklad; { RTK 2003.3.3 }
{ Reitev s skladom.  asovna zahtevnost je v najslabem primeru O(m^2). }
const MaxN = 1000; MaxM = 200000; MaxVpliv = 1000000000;
type TabelaN = array[1..MaxN] of longint;
     TabelaM = array[1..MaxM] of longint;
     TabelaB = array[1..MaxN] of boolean;
var 
  T: text; i, u, v, m, n, SP: longint; p, Kand: longint;
  Kdo, NaKoga1, Vpliv1, NaKoga, Vpliv, Sklad: ^TabelaM; 
  NaKoliko, Prvi, NajVpliv: ^TabelaN; NaSkladu: ^TabelaB;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) 
  else Assign(T, 'vplivi.in');
  Reset(T); ReadLn(T, n); ReadLn(T, m);
  
  { Preberimo vse povezave (u, v) v tabeli Kdo in NaKoga1.
    V Vpliv1 shranimo vplive povezav, v NaKoliko pa za
    vsakega inkvizitorja zapiemo, na koliko drugih vpliva. }
  New(Kdo); New(NaKoga1); New(Vpliv1); New(NaKoliko); 
  for u := 1 to n do NaKoliko^[u] := 0;
  for i := 1 to m do begin 
    ReadLn(T, u, v, p); Inc(NaKoliko^[u]);
    Kdo^[i] := u; NaKoga1^[i] := v; Vpliv1^[i] := p; 
  end; {for}
  Close(T); New(Prvi); New(NaKoga); New(Vpliv);
  
  { Povezave uredimo tako, da bomo imeli za vsakega inkvizitorja 
    pri roki seznam vseh, na katere vpliva: za inkvizitorja u
    so to inkvizitorji NaKoga^[Prvi^[u]..Prvi^[u] + NaKoliko^[u] - 1]. }
  Prvi^[1] := 1; for u := 2 to n do Prvi^[u] := Prvi^[u-1] + NaKoliko^[u-1];
  for u := 1 to n do NaKoliko^[u] := 0;
  for i := 1 to m do begin
    u := Kdo^[i]; 
    NaKoga^[Prvi^[u] + NaKoliko^[u]] := NaKoga1^[i];
    Vpliv^[Prvi^[u] + NaKoliko^[u]] := Vpliv1^[i];
    Inc(NaKoliko^[u]);
  end; {for}
  Dispose(Kdo); Dispose(NaKoga1); Dispose(Vpliv1); New(NajVpliv);
  
  { Glavni del naega postopka.  Na skladu (tabela Sklad) je SP
    tok, vrh sklada je na indeksu SP.  NaSkladu^[u] pove, 
    e je u v skladu. }
  NajVpliv^[1] := MaxVpliv + 1; for u := 2 to n do NajVpliv^[u] := -1;
  SP := 1; New(Sklad); New(NaSkladu); Sklad^[SP] := 1; 
  NaSkladu^[1] := true; for u := 2 to n do NaSkladu^[u] := false;
  while SP > 0 do begin
    u := Sklad^[SP]; NaSkladu^[u] := false; Dec(SP);    { Vzamemo nek u s sklada. }
    for i := 1 to NaKoliko^[u] do begin             { Na koga vse lahko u vpliva? }
      v := NaKoga^[Prvi^[u] + i - 1]; p := Vpliv^[Prvi^[u] + i - 1];
      if p < NajVpliv^[u] then Kand := p else Kand := NajVpliv^[u];
      if Kand > NajVpliv^[v] then begin      { Nali smo novo najboljo pot do v. }
        NajVpliv^[v] := Kand; 
        if not NaSkladu^[v] then begin                      { Dodajmo v na sklad. }
          Inc(SP); Sklad^[SP] := v; 
          NaSkladu^[v] := true; 
        end; {if}
      end; {if}
    end; {for}
  end; {while}
  Dispose(Sklad); Dispose(NaSkladu); Dispose(Vpliv); 
  Dispose(NaKoga); Dispose(NaKoliko); Dispose(Prvi);
  
  { Izpis rezultatov. }
  if ParamCount >= 2 then Assign(T, ParamStr(2)) 
  else Assign(T, 'vplivi.out');
  Rewrite(T); for u := 2 to n do WriteLn(T, NajVpliv^[u]);
  Close(T); Dispose(NajVpliv);
end. {VpliviSklad}
