program VpliviVrsta; { RTK 2003.3.3 }
{ Reitev z vrsto.  asovna zahtevnost je v najslabem primeru O(nm). }
const MaxN = 1000; MaxM = 200000; MaxVpliv = 1000000000;
type TabelaN = array[1..MaxN] of longint;
     TabelaM = array[1..MaxM] of longint;
     TabelaB = array[1..MaxN] of boolean;
var 
  T: text; i, u, v, m, n, Glava, Dolz: longint; p, Kand: longint;
  Kdo, NaKoga1, Vpliv1, NaKoga, Vpliv, Vrsta: ^TabelaM; 
  NaKoliko, Prvi, NajVpliv: ^TabelaN; VVrsti: ^TabelaB;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) 
  else Assign(T, 'vplivi.in');
  Reset(T); ReadLn(T, n); ReadLn(T, m);
  
  { Preberimo vse povezave (u, v) v tabeli Kdo in NaKoga1.
    V Vpliv1 shranimo vplive povezav, v NaKoliko pa za
    vsakega inkvizitorja zapiemo, na koliko drugih vpliva. }
  New(Kdo); New(NaKoga1); New(Vpliv1); New(NaKoliko); 
  for u := 1 to n do NaKoliko^[u] := 0;
  for i := 1 to m do begin 
    ReadLn(T, u, v, p); Inc(NaKoliko^[u]);
    Kdo^[i] := u; NaKoga1^[i] := v; Vpliv1^[i] := p; 
  end; {for}
  Close(T); New(Prvi); New(NaKoga); New(Vpliv);
  
  { Povezave uredimo tako, da bomo imeli za vsakega inkvizitorja 
    pri roki seznam vseh, na katere vpliva: za inkvizitorja u
    so to inkvizitorji NaKoga^[Prvi^[u]..Prvi^[u] + NaKoliko^[u] - 1]. }
  Prvi^[1] := 1; for u := 2 to n do Prvi^[u] := Prvi^[u-1] + NaKoliko^[u-1];
  for u := 1 to n do NaKoliko^[u] := 0;
  for i := 1 to m do begin
    u := Kdo^[i]; 
    NaKoga^[Prvi^[u] + NaKoliko^[u]] := NaKoga1^[i];
    Vpliv^[Prvi^[u] + NaKoliko^[u]] := Vpliv1^[i];
    Inc(NaKoliko^[u]);
  end; {for}
  Dispose(Kdo); Dispose(NaKoga1); Dispose(Vpliv1); New(NajVpliv);
  
  { Glavni del naega postopka.  V vrsti (tabela Vrsta) je Dolz 
    tok, prva je na indeksu Glava.  (e padejo indeksi ez rob,
    nadaljujemo pri indeksu 1.)  VVrsti^[u] pove, e je u v vrsti. }
  NajVpliv^[1] := MaxVpliv + 1; for u := 2 to n do NajVpliv^[u] := -1;
  Glava := 1; Dolz := 1; New(Vrsta); New(VVrsti); Vrsta^[Glava] := 1; 
  VVrsti^[1] := true; for u := 2 to n do VVrsti^[u] := false;
  while Dolz > 0 do begin
    u := Vrsta^[Glava]; VVrsti^[u] := false; Dec(Dolz); { Vzamemo nek u iz vrste. }
    for i := 1 to NaKoliko^[u] do begin             { Na koga vse lahko u vpliva? }
      v := NaKoga^[Prvi^[u] + i - 1]; p := Vpliv^[Prvi^[u] + i - 1];
      if p < NajVpliv^[u] then Kand := p else Kand := NajVpliv^[u];
      if Kand > NajVpliv^[v] then begin      { Nali smo novo najboljo pot do v. }
        NajVpliv^[v] := Kand; 
        if not VVrsti^[v] then begin                         { Dodajmo v v vrsto. }
          Vrsta^[(Glava + Dolz) mod n + 1] := v; 
          Inc(Dolz); VVrsti^[v] := true; 
        end; {if}
      end; {if}
    end; {for}
    Inc(Glava); if Glava > n then Glava := 1;
  end; {while}
  Dispose(Vrsta); Dispose(VVrsti); Dispose(Vpliv); 
  Dispose(NaKoga); Dispose(NaKoliko); Dispose(Prvi);
  
  { Izpis rezultatov. }
  if ParamCount >= 2 then Assign(T, ParamStr(2)) 
  else Assign(T, 'vplivi.out');
  Rewrite(T); for u := 2 to n do WriteLn(T, NajVpliv^[u]);
  Close(T); Dispose(NajVpliv);
end. {VpliviVrsta}
