program Pohlep; { RTK 2004.1.3 }

{-----------------------------------------------------------------------------}
{ Tu je implementacija podprogramov, za katere naloga pravi, naj              }
{ predpostavimo, da so e dani.  Podatke o stavah prebere podprogram          }
{ Inicializacija iz datoteke, katere ime mora biti podano kot parameter       }
{ v ukazni vrstici.  Datoteka naj ima naslednjo obliko:                       }
{                                                                             }
{ StStav                                                                      }
{ Visina[1] Kolicnik[1] KdajZadene[1]                                         }
{ . . . . . . . . . . . . . . . . . .                                         }
{ Visina[StStav] Kolicnik[StStav] KdajZadene[StStav]                          }
{                                                                             }
{ Pri tem naj bo KdajZadene[i] predstavljena kot seznam tevil, loenih s     }
{ presledki, na koncu pa naj bo tevilo -1.                                   }
{-----------------------------------------------------------------------------}

const MaxStav = 1000;
type MnozicaT = set of 0..36;
var
  nStav: integer;
  Visine, Kolicniki: array [1..MaxStav] of integer;
  KdajZadenejo: array [1..MaxStav] of MnozicaT;

function StStav: integer;
begin
  StStav := nStav;
end; {StStav}

function AliZadene(Stava, Stevilka: integer): boolean;
begin
  AliZadene := Stevilka in KdajZadenejo[Stava];
end; {AliZadene}

function VisinaStave(Stava: integer): integer;
begin
  VisinaStave := Visine[Stava];
end; {VisinaStave}

function Kolicnik(Stava: integer): integer;
begin
  Kolicnik := Kolicniki[Stava];
end; {Kolicnik}

function Inicializacija: boolean;
var T: text; i, j: integer;
begin
  if ParamCount < 1 then begin
    WriteLn('Kot parameter podajte ime datoteke s podatki o stavah.');
    Inicializacija := false; exit;
  end; {if}
  Assign(T, ParamStr(1)); Reset(T);
  Read(T, nStav); Assert(nStav >= 0); Assert(nStav <= MaxStav);
  for i := 1 to nStav do begin
    KdajZadenejo[i] := [];
    Read(T, Visine[i], Kolicniki[i], j);
    while j >= 0 do begin
      KdajZadenejo[i] := KdajZadenejo[i] + [j];
      Read(T, j);
    end; {while}
  end; {for i}
  Close(T);
  Inicializacija := true;
end; {Inicializacija}

{-----------------------------------------------------------------------------}
{ Od tu naprej je tisti del reitve, ki naj bi jo napisali tekmovalci.        }
{-----------------------------------------------------------------------------}

var NajStevilka, NajZnesek, i, Znesek, Stava: integer;
begin
  if not Inicializacija then exit;
  NajZnesek := 0;
  for i := 0 to 36 do begin
    Znesek := 0;
    for Stava := 1 to StStav do
      if AliZadene(Stava, i) then
        Znesek := Znesek + VisinaStave(Stava) * Kolicnik(Stava);
    WriteLn('e bo izrebana ', i:2, ', bomo morali plaati ', Znesek:10, '.');
    if (i = 0) or (Znesek < NajZnesek) then
      begin NajStevilka := i; NajZnesek := Znesek end;
  end; {for i}
  WriteLn('Izrebana naj bo tevilka ', NajStevilka, '.');
end. {Pohlep}
