program Sbn; { RTK 2004.3.2 }

{ Bolja implementacija urejanja z izbiranjem.
  Za n registrov dobimo 8n - 4 ukazov dolg program. 
  
  Urejanje z izbiranjem zapiimo takole:

  for i := 1 to n - 1 do begin
    m := r[n]; -- Od tu naprej si zaasno mislimo, 
               -- da je register r[n] "prazen".
    for j := n - 1 downto 1 do begin
      if j < i then continue; 
      if m < r[j] then continue;
      zamenjaj m in r[j];
    end; 
    -- Izmed vrednosti, ki so bile prvotno v registrih r[i..n],
    -- je zdaj najmanja v spremenljivki m, ostale pa so 
    -- (mogoe malo premeane) v registrih r[i..n-1].  Zdaj
    -- premaknimo vrednost r[i] v prazni register r[n],
    -- v r[i] pa vpiimo m, ki s tem pride na pravo mesto v
    -- urejenem delu tabele. 
    r[n] := r[i];     (*)
    r[i] := m;        (*)
  end;

  Vrstici (*) zamenjajmo z

    for j := 1 to n - 1 do begin
      if j < i then continue;
      r[n] := r[j];
      r[j] := m; 
      break;
    end;

  Tako v zunanji zanki (po i) nikjer ve naravnost ne dostopamo 
  do registra r[i], zato ne bo treba imeti ve kopij kode te zanke
  (po eno kopijo za vsako vrednost i).  Tako bo dolina naega
  zaporedja ukazov le O(n), ne pa O(n^2). }

const m = 254; i = 255; temp = 256;
var T: text; j, n: integer;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'sbn.in');
  Reset(T); ReadLn(T, n); Close(T);
  if ParamCount >= 2 then Assign(T, ParamStr(2)) else Assign(T, 'sbn.out');
  Rewrite(T);
  WriteLn(T, 'sbn r', i, ', ', 1, ', 0');       { i := 1 }
  Write(T, 'zanka: ');
  WriteLn(T, 'sbn r', m, ', r', n, ', 0');      { m := r[n] }
  for j := n - 1 downto 1 do begin
    WriteLn(T, 'sbn r', temp, ', ', j, ', r', i, ', _a_1');     { if j < i then break }
    WriteLn(T, 'sbn r', temp, ', r', m, ', r', j, ', _a_', j);  { if m < r[j] then continue }
    { Zamenjaj r[j] in m. }
    WriteLn(T, 'sbn r', j, ', r', m, ', 0');                    { r[j] := m }
    WriteLn(T, 'sbn r', m, ', r', j, ', r', temp);              { m := m - (m - stara r[j]) }
    Write(T, '_a_', j, ': ');
  end; {for j}
  { Zdaj je m = min(r[i..n]).  Izvesti moramo r[n] := r[i] in r[i] := m. }
  for j := 1 to n - 1 do begin
    WriteLn(T, 'sbn r', temp, ', ', j, ', r', i, ', _b_', j);   { if j < i then continue }
    { Sicer je j = i. }
    WriteLn(T, 'sbn r', n, ', r', j, ', 0');                    { r[n] := r[i] }
    WriteLn(T, 'sbn r', j, ', r', m, ', 0');                    { r[j] := m }
    WriteLn(T, 'sbn r', temp, ', 0, 1, _b_', n - 1);            { break }
    Write(T, '_b_', j, ':');
  end; {for j}
  WriteLn(T, 'sbn r', i, ', r', i, ', -1');                     { i := i + 1 }
  WriteLn(T, 'sbn r', temp, ', r', i, ', ', n, ', zanka');      { if i < n then goto zanka }
  Close(T);
end. {Sbn}
