program Butalci; { RTK 2004.3.3 }

{ Reitev z dinaminim programiranjem. }

const 
  MaxNB = 25; { najveje tevilo Butalcev }
  MaxNT = 500000; { najveje tevilo trgovcev }
  MaxVsotaCen = 1000000000; { vsota vseh cen v datoteki }
  MaxSkupajKosov = 1000000; { skupno tevilo kosov, ki so naprodaj }
var 
  T: text; 
  NB, NT, NK, ib, it, ip, Kos, Kosi, Cena, SkupajKosov: integer;
  VseCeneSkupaj: int64;
  C, Cs: array [0..MaxNB] of integer;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'pamet.in');
  Reset(T); ReadLn(T, NB, NT);
  Assert(1 <= NB); Assert(NB <= MaxNB); Assert(1 <= NT); Assert(NT <= MaxNT);
  VseCeneSkupaj := 0; SkupajKosov := 0;
  C[0] := 0; Cs[0] := 0;
  for ib := 1 to NB do C[ib] := MaxVsotaCen + 1;
  for it := 1 to NT do begin
    for ib := 1 to NB do Cs[ib] := C[ib];
    { Zdaj je v Cs[ib] najceneji nain, kako kupiti ib kosov pameti,
      e kupujemo samo od prvih it-1 trgovcev.  V C[ib] si bomo naraunali
      najceneje variante za prvih it trgovcev.  Ena od monosti je vsekakor
      ta, da od zadnjega ne kupimo niesar in je C[ib] = Cs[ib].  V nadaljevanju
      bomo preizkusili e druge monosti in si za vsak ib zapomnili najcenejo. }
    Read(T, NK); Kosi := 0;
    Assert(0 <= NK); Assert(NK <= MaxSkupajKosov);
    SkupajKosov := SkupajKosov + NK; Assert(SkupajKosov <= MaxSkupajKosov);
    for ip := 1 to NK do begin
      Read(T, Kos); Assert(0 <= Kos); Assert(Kos <= MaxVsotaCen);
      VseCeneSkupaj := VseCeneSkupaj + Kos; Assert(VseCeneSkupaj <= MaxVsotaCen);
      if ip > NB then continue;
      Kosi := Kosi + Kos;
      for ib := ip to NB do begin
        { Kako lahko najceneje dobimo ib kosov pameti, e jih pri trgovcu it kupimo ip? 
          Pri prejnjih trgovcih jih bo torej treba kupiti ib - ip. }
        if Cs[ib - ip] > MaxVsotaCen then continue; { To se sploh ne da;
          ker naloga obljublja, da nobena vsota cen pameti ne more presei 
          vrednosti MaxVsotaCen, uporabljamo veje vrednosti kot znak za to,
          da nek nakup sploh ni mogo . }
        Cena := Cs[ib - ip] + Kosi;
        { Je to najbolji doslej znani nain za ib kosov pameti? }
        if Cena < C[ib] then C[ib] := Cena;
      end; {for ib}
    end; {for ip}
    {for ib := 1 to NB do Write(C[ib], ' '); WriteLn;}
    Assert(Eoln(T)); ReadLn(T);
  end; {for it}
  Close(T);
  Assert(C[NB] <= MaxVsotaCen); { Je pameti res za vse dovolj? }
  { Izpiimo rezultat. }
  if ParamCount >= 2 then Assign(T, ParamStr(2)) else Assign(T, 'pamet.out');
  Rewrite(T); WriteLn(T, C[NB]); Close(T);
end. {Butalci}
