program Pretvorba; { RTK 2002.X.2 }
{$IFDEF MERICAS}
uses Windows;
{$ENDIF}
type TabelaT = array [0..5] of char;
var T: TabelaT; tn: integer;
  
procedure PutChar(c: char);
begin
  Assert(tn < 6);
  if tn < 6 then T[tn] := c; 
  tn := tn + 1;
end; {PutChar}

procedure UTF8_1(c: integer);
begin
  if c < $80 then
    PutChar(Chr(c))
  else if c < $800 then begin
    PutChar(Chr($C0 or (c shr 6)));
    PutChar(Chr($80 or (c and $3F)));
  end else if c < $10000 then begin
    PutChar(Chr($E0 or (c shr 12)));
    PutChar(Chr($80 or ((c shr 6) and $3F)));
    PutChar(Chr($80 or (c and $3F)));
  end else if c < $200000 then begin
    PutChar(Chr($F0 or (c shr 18)));
    PutChar(Chr($80 or ((c shr 12) and $3F)));
    PutChar(Chr($80 or ((c shr 6) and $3F)));
    PutChar(Chr($80 or (c and $3F)));
  end else if c < $4000000 then begin
    PutChar(Chr($F8 or (c shr 24)));
    PutChar(Chr($80 or ((c shr 18) and $3F)));
    PutChar(Chr($80 or ((c shr 12) and $3F)));
    PutChar(Chr($80 or ((c shr 6) and $3F)));
    PutChar(Chr($80 or (c and $3F)));
  end else begin
    PutChar(Chr($FC or (c shr 30)));
    PutChar(Chr($80 or ((c shr 24) and $3F)));
    PutChar(Chr($80 or ((c shr 18) and $3F)));
    PutChar(Chr($80 or ((c shr 12) and $3F)));
    PutChar(Chr($80 or ((c shr 6) and $3F)));
    PutChar(Chr($80 or (c and $3F)));
  end; {if}
end; {UTF8_1}

procedure UTF8_2(c: integer);
var n, cc, k: integer;
begin
  if c < 128 then begin PutChar(chr(c)); exit end;
  { n naj bo indeks najvijega priganega bita (0..31) v c-ju. }
  cc := c; n := 0;
  while cc <> 1 do begin n := n + 1; cc := cc shr 1 end;
  if n > 30 then begin WriteLn('Napaka!'); exit end;
  { Koliko bytov bo treba izpisati? }
  k := (n + 4) div 5;
  { V prvem izpisanem bytu mora biti priganih vrhnjih k bitov. }
  PutChar(Chr((((1 shl k) - 1) shl (8 - k)) or (c shr (6 * (k - 1)))));
  { V vsakem nadaljnjem bytu izpiemo po 6 bitov c-ja. }
  while k > 1 do begin
    k := k - 1;
    PutChar(Chr(128 or ((c shr (6 * (k - 1))) and 63)));
  end; {while}
end; {UTF8_2}

{ Poskusi pretvoriti v UTF vse znake od 0 do 2^31 - 1 
  in preveri, e dajeta UTF8_1 in UTF8_2 enake rezultate. }
procedure PreizkusiVse;
var T2: TabelaT; tn2, c, i: integer; 
begin
  c := 0;
  while true do begin
    if (c mod 1000000) = 0 then Write(c, chr(13), chr(10));
    tn := 0;
    UTF8_2(c);
    T2 := T; tn2 := tn;
    tn := 0;
    UTF8_1(c);
    Assert(tn = tn2);
    for i := 0 to tn - 1 do Assert(T[i] = T2[i]);
    if c = $7fffffff then break;
    c := c + 1;
  end; {while}
  { Pri naslednjih tirih bi se morale izpisovati napake. }
  tn := 0;
  c := $80000000; UTF8_1(c); Assert(tn = 0); UTF8_2(c); Assert(tn = 0); 
  c := $87654321; UTF8_1(c); Assert(tn = 0); UTF8_2(c); Assert(tn = 0); 
  c := $baadc0de; UTF8_1(c); Assert(tn = 0); UTF8_2(c); Assert(tn = 0); 
  c := $ffffffff; UTF8_1(c); Assert(tn = 0); UTF8_2(c); Assert(tn = 0); 
end; {PreizkusiVse}

{$IFDEF MERICAS}
function Cas: double;
var ct, et, kt, ut: FILETIME;
begin
  GetProcessTimes(GetCurrentProcess(), ct, et, kt, ut);
  Cas := (int64(kt) + int64(ut)) / 10000000.0;
end; {Cas}

procedure MeriCas(Prvi, Zadnji, Kolikokrat: integer);
var c, i: integer; t1, t2: double;
begin
  t1 := Cas;
  for i := 1 to Kolikokrat do begin
    c := Prvi;
    while true do begin
      tn := 0; UTF8_1(c);
      if c = Zadnji then break;
      c := c + 1;
    end; {while}
  end; {for i}
  t2 := Cas;
  WriteLn('UTF8_1(', Prvi, '..', Zadnji, ') = ', ((t2 - t1) / Kolikokrat):0:8, ' s');
  t1 := Cas;
  for i := 1 to Kolikokrat do begin
    c := Prvi;
    while true do begin
      tn := 0; UTF8_2(c);
      if c = Zadnji then break;
      c := c + 1;
    end; {while}
  end; {for i}
  t2 := Cas;
  WriteLn('UTF8_2(', Prvi, '..', Zadnji, ') = ', ((t2 - t1) / Kolikokrat):0:8, ' s');
end; {MeriCas}
{$ENDIF}

begin {Pretvorba}
  {PreizkusiVse;}
{$IFDEF MERICAS}
  MeriCas(0, $7f, 1000000);
  MeriCas($80, $7ff, 100000);
  MeriCas($800, $ffff, 1000);
  MeriCas($10000, $1fffff, 10);
  MeriCas($200000, $3ffffff, 1);
  MeriCas($4000000, $7fffffff, 1);
{$ENDIF}
end. {Pretvorba}

{   Interval        as UTF8_1     as UTF8_2        Razmerje
      0..7F           1.97 us        2.03 us            1.0
     80..7FF            45 us         249 us            5.4
    800..FFFF         1.97 ms        10.6 ms            5.4
  10000..1FFFFF         71 ms         444 ms            6.2
 200000..3FFFFFF       2.9 s         16.8 s             5.7
4000000..7FFFFFFF      112 s          597 s             5.3 }
