program Stikala; { RTK 2003.X.7 }
uses Crt;

  { Podprogrami, za katere naloga pravi, da lahko predpostavimo,
    da e obstajajo. }
  function StStikal: integer; forward; 
  function MaxHkratiOdkljukanih: integer; forward; 
  function JeOdkljukano(StStikala: integer): boolean; forward; 
  procedure PostaviStikalo(StStikala: integer; Odkljukano: boolean); forward;

{ To je podprogram, ki ga je moral napisati tekmovalec. }
procedure KlicanObSpremembi(StStikala: integer);
var i, StOdkljukanih, NekoOdkljukano: integer;
begin
  { e je uporabnik stikalo izkljuil, zdaj gotovo ni vkljuenih preve stikal. }
  if not JeOdkljukano(StStikala) then exit; 
  { Pretejmo odkljukana stikala. }
  StOdkljukanih := 0; NekoOdkljukano := StStikala;
  for i := 1 to StStikal do if JeOdkljukano(i) then begin
    if i <> StStikala then NekoOdkljukano := i;
    StOdkljukanih := StOdkljukanih + 1;
    if StOdkljukanih > MaxHkratiOdkljukanih then break;
  end; {for i, if}
  { Izkljuimo kakno stikalo, e je to potrebno. }
  if StOdkljukanih > MaxHkratiOdkljukanih then
    PostaviStikalo(NekoOdkljukano,  false);
end; {KlicanObSpremembi}

{-----------------------------------------------------------------------------}
{ Preostanek programa je simulator skupine stikal. }

const MaxStikal = 30;
var
  nStikal, MaxHkrati: integer;
  Stanje: array [1..MaxStikal] of boolean;

function StStikal: integer;
begin
  StStikal := nStikal;
end; {StStikal}

function MaxHkratiOdkljukanih: integer;
begin
  MaxHkratiOdkljukanih := MaxHkrati;
end; {MaxHkratiOdkljuknih}

function JeOdkljukano(StStikala: integer): boolean;
begin
  Assert(1 <= StStikala); Assert(StStikala <= nStikal);
  JeOdkljukano := Stanje[StStikala];
end; {JeOdkljukano}

procedure PostaviStikalo(StStikala: integer; Odkljukano: boolean);
begin
  Assert(1 <= StStikala); Assert(StStikala <= nStikal);
  Stanje[StStikala] := Odkljukano;
end; {PostaviStikalo}

var c: char; StStikala: integer;
begin {Stikala}
  WriteLn('Simulator skupine stikal');
  WriteLn('+, - = spremeni tevilo stikal;  <, > = spremeni najveje dovoljeno tevilo');
  WriteLn('hkrati priganih stikal;  0..9, A..Z = pritisk na stikalo;  escape = izhod.');
  WriteLn;
  nStikal := 10; MaxHkrati := 5;
  while true do begin
    { Prikaimo stanje. }
    Write('n = ', nStikal, ', m = ', MaxHkrati, '   ');
    for StStikala := 1 to nStikal do 
      if Stanje[StStikala] then Write('#') else Write('.');
    Write('    ', Chr(13));
    { Odzivajmo se na pritiske na tipke. }
    c := ReadKey;
    if c = Chr(0) then begin c := ReadKey; continue end;
    case c of
    '+': if nStikal < MaxStikal then
        begin nStikal := nStikal + 1; Stanje[nStikal] := false end;
    '-': begin
      if nStikal > 0 then nStikal := nStikal - 1;
      if MaxHkrati > nStikal then MaxHkrati := nStikal;
    end;
    '>': if MaxHkrati < nStikal then MaxHkrati := MaxHkrati + 1;
    '<': if MaxHkrati > 0 then MaxHkrati := MaxHkrati - 1;
    '0'..'9', 'A'..'Z', 'a'..'z': begin
      if c in ['0'..'9'] then StStikala := 1 + Ord(c) - Ord('0')
      else if c in ['A'..'Z'] then StStikala := 11 + Ord(c) - Ord('A')
      else StStikala := 11 + Ord(c) - Ord('a');
      if (StStikala < 1) or (StStikala > nStikal) then continue;
      Stanje[StStikala] := not Stanje[StStikala];
      KlicanObSpremembi(StStikala);
    end;
    Chr(27): break;
    end; {case c}
  end; {while}
  WriteLn;
end. {Stikala}
