program RibaRibiRiba; { RTK 2004.X }
const MaxN = 100;
var A: array [1..MaxN] of integer; N: integer;

function NajboljsaVsota1: integer;

  function NajboljsaVsota(Z: integer): integer;
  var L, R, T, Vsota, aL1, aR1: integer;
  begin
    L := Z; R := Z; T := A[Z]; Vsota := T; { Trenutna riba je Z, porta ni e nobena. }
    while (L > 0) or (R < N) do begin
      { Trenutna riba je bodisi L ali pa R, vse ostale iz podzaporedja L..R pa so 
        e porte.  Trenutno ribo lahko torej pore bodisi riba L - 1 ali pa riba R + 1.
        Poglejmo, kako veliki sta tidve ribi; e smo e na robovih zaporedja,
        si mislimo, da sta tam neki majhni ribi, ki trenutne ne moreta poreti. }
      if L > 1 then aL1 := A[L - 1] else aL1 := T - 1;
      if R < N then aR1 := A[R + 1] else aR1 := T - 1;
      { Mogoe nas ne more poreti nobena od sosed. }
      if (aL1 < T) and (aR1 < T) then break;
      { e nas lahko pore le ena, naj nas pa tista; e obe, pa naj nas pore manja od njiju. }
      if (aR1 < T) or ((T <= aL1) and (aL1 <= aR1))
      then begin Vsota := Vsota + aL1; L := L - 1; T := aL1 end
      else begin Vsota := Vsota + aR1; R := R + 1; T := aR1 end;
      {WriteLn('Vsota(', L, '..', R, ') = ', Vsota, ', T = ', T);}
    end; {while}
    {WriteLn('NajVsota(', Z, ') = ', Vsota, ' (', L, '..', R, ')');}
    NajboljsaVsota := Vsota;
  end; {NajboljsaVsota}

var Z, Vsota, NajVsota: integer;
begin
  NajVsota := 0;
  for Z := 1 to N do begin
    Vsota := NajboljsaVsota(Z);
    if (Z = 1) or (Vsota > NajVsota) then NajVsota := Vsota;
  end; {Z}
  NajboljsaVsota1 := NajVsota;
end; {NajboljsaVsota}

function NajboljsaVsota2: integer;
var Z, LZ, RZ, Vsota, NajVsota, S: integer;
begin
  LZ := 1; RZ := 0; Vsota := 0; NajVsota := 0;
  for Z := 1 to N do begin
    { Trenutno je v LZ vrednost l_(z-1), v RZ pa r_(z-1). 
      Izraunajmo novi LZ = l_z. }
    if Z = 1 then S := A[Z] - 1 else S := A[Z - 1];
    if S < A[Z] then { Z je levi maksimum; poveajmo LZ do Z. }
      while LZ < Z do begin Vsota := Vsota - A[LZ]; LZ := LZ + 1 end;
    { Izraunajmo novi RZ = r_z. }
    if RZ < Z then { Z - 1 je bil desni maksimum, zdaj pa moramo najti naslednjega. }
      repeat
        RZ := RZ + 1; Vsota := Vsota + A[RZ];
        if RZ = N then S := A[RZ] - 1 else S := A[RZ + 1];
      until S < A[RZ];
    { Zdaj imamo v LZ pravo l_z, v RZ pa r_z.  V spremenljivki Vsota je
      vsota velikosti vseh rib od LZ do RZ; mogoe je to najbolja vsota doslej. }
    {WriteLn('Z = ', Z, ', LZ = ', LZ, ', RZ = ', RZ, ' Vsota = ', Vsota);}
    if Vsota > NajVsota then NajVsota := Vsota;
  end; {for Z}
  NajboljsaVsota2 := NajVsota;
end; {NajboljsaVsota2}

procedure Test;
var V1, V2, i: integer;
begin
  V1 := NajboljsaVsota1; V2 := NajboljsaVsota2;
  if V1 <> V2 then begin
    WriteLn('N = ', N, ', NajboljsaVsota1 = ', V1, ', NajboljsaVsota2 = ', V2);
    for i := 1 to N do Write(A[i], ' ');
    WriteLn;
    Halt;
  end; {if}
end; {Test}

var i, j: integer;
begin {RibaRibiRiba}
  N := 10;
  {for j := 1 to N do A[j] := j;
  Test;
  for j := 1 to N do A[j] := N + 1 - j;
  Test;}
  for j := 1 to N div 2 do A[j] := j;
  for j := (N div 2) + 1 to N do A[j] := N + 1 - j;
  Test;
  for j := 1 to N div 2 do A[j] := N + 1 - j;
  for j := (N div 2) + 1 to N do A[j] := j;
  Test;
  for i := 1 to 100000 do begin
    N := Random(50) + 50;
    for j := 1 to N do A[j] := Random(100) + 100;
    Test;
  end; {for i}
  for i := 1 to 100000 do begin
    N := Random(50) + 50;
    for j := 1 to N do A[j] := Random(10) + 1;
    Test;
  end; {for i}
end. {RibaRibiRiba}
